/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * Sparc Disassembler                                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/


#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/TargetParser/SubtargetFeature.h"
#include <assert.h>

namespace {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static void insertBits(InsnType &field, InsnType bits, unsigned startBit,
                       unsigned numBits) {
  if constexpr (std::is_integral<InsnType>::value) {
    assert(startBit + numBits <= sizeof field * 8);
    field |= (InsnType)bits << startBit;
  } else {
    field.insertBits(bits, startBit, numBits);
  }
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTableSparc32[] = {
/* 0 */       MCD::OPC_ExtractField, 30, 2,  // Inst{31-30} ...
/* 3 */       MCD::OPC_FilterValue, 0, 129, 1, // Skip to: 392
/* 7 */       MCD::OPC_ExtractField, 22, 3,  // Inst{24-22} ...
/* 10 */      MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 24
/* 14 */      MCD::OPC_CheckField, 25, 5, 0, 32, 26, // Skip to: 6708
/* 20 */      MCD::OPC_Decode, 160, 6, 0, // Opcode: UNIMP
/* 24 */      MCD::OPC_FilterValue, 1, 111, 0, // Skip to: 139
/* 28 */      MCD::OPC_ExtractField, 19, 3,  // Inst{21-19} ...
/* 31 */      MCD::OPC_FilterValue, 0, 27, 0, // Skip to: 62
/* 35 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 38 */      MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 50
/* 42 */      MCD::OPC_CheckPredicate, 0, 6, 26, // Skip to: 6708
/* 46 */      MCD::OPC_Decode, 237, 2, 1, // Opcode: BPICCNT
/* 50 */      MCD::OPC_FilterValue, 1, 254, 25, // Skip to: 6708
/* 54 */      MCD::OPC_CheckPredicate, 0, 250, 25, // Skip to: 6708
/* 58 */      MCD::OPC_Decode, 236, 2, 1, // Opcode: BPICCANT
/* 62 */      MCD::OPC_FilterValue, 1, 27, 0, // Skip to: 93
/* 66 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 69 */      MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 81
/* 73 */      MCD::OPC_CheckPredicate, 0, 231, 25, // Skip to: 6708
/* 77 */      MCD::OPC_Decode, 234, 2, 1, // Opcode: BPICC
/* 81 */      MCD::OPC_FilterValue, 1, 223, 25, // Skip to: 6708
/* 85 */      MCD::OPC_CheckPredicate, 0, 219, 25, // Skip to: 6708
/* 89 */      MCD::OPC_Decode, 235, 2, 1, // Opcode: BPICCA
/* 93 */      MCD::OPC_FilterValue, 4, 19, 0, // Skip to: 116
/* 97 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 100 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 108
/* 104 */     MCD::OPC_Decode, 245, 2, 1, // Opcode: BPXCCNT
/* 108 */     MCD::OPC_FilterValue, 1, 196, 25, // Skip to: 6708
/* 112 */     MCD::OPC_Decode, 244, 2, 1, // Opcode: BPXCCANT
/* 116 */     MCD::OPC_FilterValue, 5, 188, 25, // Skip to: 6708
/* 120 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 123 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 131
/* 127 */     MCD::OPC_Decode, 242, 2, 1, // Opcode: BPXCC
/* 131 */     MCD::OPC_FilterValue, 1, 173, 25, // Skip to: 6708
/* 135 */     MCD::OPC_Decode, 243, 2, 1, // Opcode: BPXCCA
/* 139 */     MCD::OPC_FilterValue, 2, 29, 0, // Skip to: 172
/* 143 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 146 */     MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 164
/* 150 */     MCD::OPC_CheckField, 25, 4, 8, 4, 0, // Skip to: 160
/* 156 */     MCD::OPC_Decode, 224, 2, 0, // Opcode: BA
/* 160 */     MCD::OPC_Decode, 225, 2, 2, // Opcode: BCOND
/* 164 */     MCD::OPC_FilterValue, 1, 140, 25, // Skip to: 6708
/* 168 */     MCD::OPC_Decode, 226, 2, 2, // Opcode: BCONDA
/* 172 */     MCD::OPC_FilterValue, 3, 49, 0, // Skip to: 225
/* 176 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 179 */     MCD::OPC_FilterValue, 0, 19, 0, // Skip to: 202
/* 183 */     MCD::OPC_ExtractField, 28, 2,  // Inst{29-28} ...
/* 186 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 194
/* 190 */     MCD::OPC_Decode, 241, 2, 3, // Opcode: BPRNT
/* 194 */     MCD::OPC_FilterValue, 2, 110, 25, // Skip to: 6708
/* 198 */     MCD::OPC_Decode, 240, 2, 3, // Opcode: BPRANT
/* 202 */     MCD::OPC_FilterValue, 1, 102, 25, // Skip to: 6708
/* 206 */     MCD::OPC_ExtractField, 28, 2,  // Inst{29-28} ...
/* 209 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 217
/* 213 */     MCD::OPC_Decode, 238, 2, 3, // Opcode: BPR
/* 217 */     MCD::OPC_FilterValue, 2, 87, 25, // Skip to: 6708
/* 221 */     MCD::OPC_Decode, 239, 2, 3, // Opcode: BPRA
/* 225 */     MCD::OPC_FilterValue, 4, 20, 0, // Skip to: 249
/* 229 */     MCD::OPC_CheckField, 25, 5, 0, 10, 0, // Skip to: 245
/* 235 */     MCD::OPC_CheckField, 0, 22, 0, 4, 0, // Skip to: 245
/* 241 */     MCD::OPC_Decode, 128, 5, 4, // Opcode: NOP
/* 245 */     MCD::OPC_Decode, 171, 5, 5, // Opcode: SETHIi
/* 249 */     MCD::OPC_FilterValue, 5, 93, 0, // Skip to: 346
/* 253 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 256 */     MCD::OPC_FilterValue, 0, 27, 0, // Skip to: 287
/* 260 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 263 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 275
/* 267 */     MCD::OPC_CheckPredicate, 0, 37, 25, // Skip to: 6708
/* 271 */     MCD::OPC_Decode, 233, 2, 6, // Opcode: BPFCCNT
/* 275 */     MCD::OPC_FilterValue, 1, 29, 25, // Skip to: 6708
/* 279 */     MCD::OPC_CheckPredicate, 0, 25, 25, // Skip to: 6708
/* 283 */     MCD::OPC_Decode, 232, 2, 6, // Opcode: BPFCCANT
/* 287 */     MCD::OPC_FilterValue, 1, 17, 25, // Skip to: 6708
/* 291 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 294 */     MCD::OPC_FilterValue, 0, 22, 0, // Skip to: 320
/* 298 */     MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 312
/* 302 */     MCD::OPC_CheckField, 20, 2, 0, 4, 0, // Skip to: 312
/* 308 */     MCD::OPC_Decode, 163, 3, 1, // Opcode: FBCOND_V9
/* 312 */     MCD::OPC_CheckPredicate, 0, 248, 24, // Skip to: 6708
/* 316 */     MCD::OPC_Decode, 230, 2, 6, // Opcode: BPFCC
/* 320 */     MCD::OPC_FilterValue, 1, 240, 24, // Skip to: 6708
/* 324 */     MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 338
/* 328 */     MCD::OPC_CheckField, 20, 2, 0, 4, 0, // Skip to: 338
/* 334 */     MCD::OPC_Decode, 162, 3, 1, // Opcode: FBCONDA_V9
/* 338 */     MCD::OPC_CheckPredicate, 0, 222, 24, // Skip to: 6708
/* 342 */     MCD::OPC_Decode, 231, 2, 6, // Opcode: BPFCCA
/* 346 */     MCD::OPC_FilterValue, 6, 19, 0, // Skip to: 369
/* 350 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 353 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 361
/* 357 */     MCD::OPC_Decode, 160, 3, 2, // Opcode: FBCOND
/* 361 */     MCD::OPC_FilterValue, 1, 199, 24, // Skip to: 6708
/* 365 */     MCD::OPC_Decode, 161, 3, 2, // Opcode: FBCONDA
/* 369 */     MCD::OPC_FilterValue, 7, 191, 24, // Skip to: 6708
/* 373 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 376 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 384
/* 380 */     MCD::OPC_Decode, 129, 3, 2, // Opcode: CBCOND
/* 384 */     MCD::OPC_FilterValue, 1, 176, 24, // Skip to: 6708
/* 388 */     MCD::OPC_Decode, 130, 3, 2, // Opcode: CBCONDA
/* 392 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 400
/* 396 */     MCD::OPC_Decode, 247, 2, 7, // Opcode: CALL
/* 400 */     MCD::OPC_FilterValue, 2, 37, 19, // Skip to: 5305
/* 404 */     MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 407 */     MCD::OPC_FilterValue, 0, 25, 0, // Skip to: 436
/* 411 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 414 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 428
/* 418 */     MCD::OPC_CheckField, 5, 8, 0, 140, 24, // Skip to: 6708
/* 424 */     MCD::OPC_Decode, 209, 2, 8, // Opcode: ADDrr
/* 428 */     MCD::OPC_FilterValue, 1, 132, 24, // Skip to: 6708
/* 432 */     MCD::OPC_Decode, 208, 2, 9, // Opcode: ADDri
/* 436 */     MCD::OPC_FilterValue, 1, 25, 0, // Skip to: 465
/* 440 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 443 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 457
/* 447 */     MCD::OPC_CheckField, 5, 8, 0, 111, 24, // Skip to: 6708
/* 453 */     MCD::OPC_Decode, 220, 2, 8, // Opcode: ANDrr
/* 457 */     MCD::OPC_FilterValue, 1, 103, 24, // Skip to: 6708
/* 461 */     MCD::OPC_Decode, 219, 2, 9, // Opcode: ANDri
/* 465 */     MCD::OPC_FilterValue, 2, 25, 0, // Skip to: 494
/* 469 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 472 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 486
/* 476 */     MCD::OPC_CheckField, 5, 8, 0, 82, 24, // Skip to: 6708
/* 482 */     MCD::OPC_Decode, 137, 5, 8, // Opcode: ORrr
/* 486 */     MCD::OPC_FilterValue, 1, 74, 24, // Skip to: 6708
/* 490 */     MCD::OPC_Decode, 136, 5, 9, // Opcode: ORri
/* 494 */     MCD::OPC_FilterValue, 3, 25, 0, // Skip to: 523
/* 498 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 501 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 515
/* 505 */     MCD::OPC_CheckField, 5, 8, 0, 53, 24, // Skip to: 6708
/* 511 */     MCD::OPC_Decode, 191, 6, 8, // Opcode: XORrr
/* 515 */     MCD::OPC_FilterValue, 1, 45, 24, // Skip to: 6708
/* 519 */     MCD::OPC_Decode, 190, 6, 9, // Opcode: XORri
/* 523 */     MCD::OPC_FilterValue, 4, 25, 0, // Skip to: 552
/* 527 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 530 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 544
/* 534 */     MCD::OPC_CheckField, 5, 8, 0, 24, 24, // Skip to: 6708
/* 540 */     MCD::OPC_Decode, 247, 5, 8, // Opcode: SUBrr
/* 544 */     MCD::OPC_FilterValue, 1, 16, 24, // Skip to: 6708
/* 548 */     MCD::OPC_Decode, 246, 5, 9, // Opcode: SUBri
/* 552 */     MCD::OPC_FilterValue, 5, 25, 0, // Skip to: 581
/* 556 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 559 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 573
/* 563 */     MCD::OPC_CheckField, 5, 8, 0, 251, 23, // Skip to: 6708
/* 569 */     MCD::OPC_Decode, 218, 2, 8, // Opcode: ANDNrr
/* 573 */     MCD::OPC_FilterValue, 1, 243, 23, // Skip to: 6708
/* 577 */     MCD::OPC_Decode, 217, 2, 9, // Opcode: ANDNri
/* 581 */     MCD::OPC_FilterValue, 6, 25, 0, // Skip to: 610
/* 585 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 588 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 602
/* 592 */     MCD::OPC_CheckField, 5, 8, 0, 222, 23, // Skip to: 6708
/* 598 */     MCD::OPC_Decode, 135, 5, 8, // Opcode: ORNrr
/* 602 */     MCD::OPC_FilterValue, 1, 214, 23, // Skip to: 6708
/* 606 */     MCD::OPC_Decode, 134, 5, 9, // Opcode: ORNri
/* 610 */     MCD::OPC_FilterValue, 7, 25, 0, // Skip to: 639
/* 614 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 617 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 631
/* 621 */     MCD::OPC_CheckField, 5, 8, 0, 193, 23, // Skip to: 6708
/* 627 */     MCD::OPC_Decode, 187, 6, 8, // Opcode: XNORrr
/* 631 */     MCD::OPC_FilterValue, 1, 185, 23, // Skip to: 6708
/* 635 */     MCD::OPC_Decode, 186, 6, 9, // Opcode: XNORri
/* 639 */     MCD::OPC_FilterValue, 8, 25, 0, // Skip to: 668
/* 643 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 646 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 660
/* 650 */     MCD::OPC_CheckField, 5, 8, 0, 164, 23, // Skip to: 6708
/* 656 */     MCD::OPC_Decode, 203, 2, 8, // Opcode: ADDCrr
/* 660 */     MCD::OPC_FilterValue, 1, 156, 23, // Skip to: 6708
/* 664 */     MCD::OPC_Decode, 202, 2, 9, // Opcode: ADDCri
/* 668 */     MCD::OPC_FilterValue, 9, 25, 0, // Skip to: 697
/* 672 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 675 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 689
/* 679 */     MCD::OPC_CheckField, 5, 8, 0, 135, 23, // Skip to: 6708
/* 685 */     MCD::OPC_Decode, 255, 4, 10, // Opcode: MULXrr
/* 689 */     MCD::OPC_FilterValue, 1, 127, 23, // Skip to: 6708
/* 693 */     MCD::OPC_Decode, 254, 4, 11, // Opcode: MULXri
/* 697 */     MCD::OPC_FilterValue, 10, 25, 0, // Skip to: 726
/* 701 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 704 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 718
/* 708 */     MCD::OPC_CheckField, 5, 8, 0, 106, 23, // Skip to: 6708
/* 714 */     MCD::OPC_Decode, 159, 6, 8, // Opcode: UMULrr
/* 718 */     MCD::OPC_FilterValue, 1, 98, 23, // Skip to: 6708
/* 722 */     MCD::OPC_Decode, 158, 6, 9, // Opcode: UMULri
/* 726 */     MCD::OPC_FilterValue, 11, 25, 0, // Skip to: 755
/* 730 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 733 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 747
/* 737 */     MCD::OPC_CheckField, 5, 8, 0, 77, 23, // Skip to: 6708
/* 743 */     MCD::OPC_Decode, 184, 5, 8, // Opcode: SMULrr
/* 747 */     MCD::OPC_FilterValue, 1, 69, 23, // Skip to: 6708
/* 751 */     MCD::OPC_Decode, 183, 5, 9, // Opcode: SMULri
/* 755 */     MCD::OPC_FilterValue, 12, 25, 0, // Skip to: 784
/* 759 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 762 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 776
/* 766 */     MCD::OPC_CheckField, 5, 8, 0, 48, 23, // Skip to: 6708
/* 772 */     MCD::OPC_Decode, 243, 5, 8, // Opcode: SUBCrr
/* 776 */     MCD::OPC_FilterValue, 1, 40, 23, // Skip to: 6708
/* 780 */     MCD::OPC_Decode, 242, 5, 9, // Opcode: SUBCri
/* 784 */     MCD::OPC_FilterValue, 13, 25, 0, // Skip to: 813
/* 788 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 791 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 805
/* 795 */     MCD::OPC_CheckField, 5, 8, 0, 19, 23, // Skip to: 6708
/* 801 */     MCD::OPC_Decode, 150, 6, 10, // Opcode: UDIVXrr
/* 805 */     MCD::OPC_FilterValue, 1, 11, 23, // Skip to: 6708
/* 809 */     MCD::OPC_Decode, 149, 6, 11, // Opcode: UDIVXri
/* 813 */     MCD::OPC_FilterValue, 14, 25, 0, // Skip to: 842
/* 817 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 820 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 834
/* 824 */     MCD::OPC_CheckField, 5, 8, 0, 246, 22, // Skip to: 6708
/* 830 */     MCD::OPC_Decode, 152, 6, 8, // Opcode: UDIVrr
/* 834 */     MCD::OPC_FilterValue, 1, 238, 22, // Skip to: 6708
/* 838 */     MCD::OPC_Decode, 151, 6, 9, // Opcode: UDIVri
/* 842 */     MCD::OPC_FilterValue, 15, 25, 0, // Skip to: 871
/* 846 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 849 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 863
/* 853 */     MCD::OPC_CheckField, 5, 8, 0, 217, 22, // Skip to: 6708
/* 859 */     MCD::OPC_Decode, 170, 5, 8, // Opcode: SDIVrr
/* 863 */     MCD::OPC_FilterValue, 1, 209, 22, // Skip to: 6708
/* 867 */     MCD::OPC_Decode, 169, 5, 9, // Opcode: SDIVri
/* 871 */     MCD::OPC_FilterValue, 16, 25, 0, // Skip to: 900
/* 875 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 878 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 892
/* 882 */     MCD::OPC_CheckField, 5, 8, 0, 188, 22, // Skip to: 6708
/* 888 */     MCD::OPC_Decode, 201, 2, 8, // Opcode: ADDCCrr
/* 892 */     MCD::OPC_FilterValue, 1, 180, 22, // Skip to: 6708
/* 896 */     MCD::OPC_Decode, 200, 2, 9, // Opcode: ADDCCri
/* 900 */     MCD::OPC_FilterValue, 17, 25, 0, // Skip to: 929
/* 904 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 907 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 921
/* 911 */     MCD::OPC_CheckField, 5, 8, 0, 159, 22, // Skip to: 6708
/* 917 */     MCD::OPC_Decode, 214, 2, 8, // Opcode: ANDCCrr
/* 921 */     MCD::OPC_FilterValue, 1, 151, 22, // Skip to: 6708
/* 925 */     MCD::OPC_Decode, 213, 2, 9, // Opcode: ANDCCri
/* 929 */     MCD::OPC_FilterValue, 18, 25, 0, // Skip to: 958
/* 933 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 936 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 950
/* 940 */     MCD::OPC_CheckField, 5, 8, 0, 130, 22, // Skip to: 6708
/* 946 */     MCD::OPC_Decode, 131, 5, 8, // Opcode: ORCCrr
/* 950 */     MCD::OPC_FilterValue, 1, 122, 22, // Skip to: 6708
/* 954 */     MCD::OPC_Decode, 130, 5, 9, // Opcode: ORCCri
/* 958 */     MCD::OPC_FilterValue, 19, 25, 0, // Skip to: 987
/* 962 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 965 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 979
/* 969 */     MCD::OPC_CheckField, 5, 8, 0, 101, 22, // Skip to: 6708
/* 975 */     MCD::OPC_Decode, 189, 6, 8, // Opcode: XORCCrr
/* 979 */     MCD::OPC_FilterValue, 1, 93, 22, // Skip to: 6708
/* 983 */     MCD::OPC_Decode, 188, 6, 9, // Opcode: XORCCri
/* 987 */     MCD::OPC_FilterValue, 20, 25, 0, // Skip to: 1016
/* 991 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 994 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1008
/* 998 */     MCD::OPC_CheckField, 5, 8, 0, 72, 22, // Skip to: 6708
/* 1004 */    MCD::OPC_Decode, 241, 5, 8, // Opcode: SUBCCrr
/* 1008 */    MCD::OPC_FilterValue, 1, 64, 22, // Skip to: 6708
/* 1012 */    MCD::OPC_Decode, 240, 5, 9, // Opcode: SUBCCri
/* 1016 */    MCD::OPC_FilterValue, 21, 25, 0, // Skip to: 1045
/* 1020 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1023 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1037
/* 1027 */    MCD::OPC_CheckField, 5, 8, 0, 43, 22, // Skip to: 6708
/* 1033 */    MCD::OPC_Decode, 216, 2, 8, // Opcode: ANDNCCrr
/* 1037 */    MCD::OPC_FilterValue, 1, 35, 22, // Skip to: 6708
/* 1041 */    MCD::OPC_Decode, 215, 2, 9, // Opcode: ANDNCCri
/* 1045 */    MCD::OPC_FilterValue, 22, 25, 0, // Skip to: 1074
/* 1049 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1052 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1066
/* 1056 */    MCD::OPC_CheckField, 5, 8, 0, 14, 22, // Skip to: 6708
/* 1062 */    MCD::OPC_Decode, 133, 5, 8, // Opcode: ORNCCrr
/* 1066 */    MCD::OPC_FilterValue, 1, 6, 22, // Skip to: 6708
/* 1070 */    MCD::OPC_Decode, 132, 5, 9, // Opcode: ORNCCri
/* 1074 */    MCD::OPC_FilterValue, 23, 25, 0, // Skip to: 1103
/* 1078 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1081 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1095
/* 1085 */    MCD::OPC_CheckField, 5, 8, 0, 241, 21, // Skip to: 6708
/* 1091 */    MCD::OPC_Decode, 185, 6, 8, // Opcode: XNORCCrr
/* 1095 */    MCD::OPC_FilterValue, 1, 233, 21, // Skip to: 6708
/* 1099 */    MCD::OPC_Decode, 184, 6, 9, // Opcode: XNORCCri
/* 1103 */    MCD::OPC_FilterValue, 24, 25, 0, // Skip to: 1132
/* 1107 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1110 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1124
/* 1114 */    MCD::OPC_CheckField, 5, 8, 0, 212, 21, // Skip to: 6708
/* 1120 */    MCD::OPC_Decode, 205, 2, 8, // Opcode: ADDErr
/* 1124 */    MCD::OPC_FilterValue, 1, 204, 21, // Skip to: 6708
/* 1128 */    MCD::OPC_Decode, 204, 2, 9, // Opcode: ADDEri
/* 1132 */    MCD::OPC_FilterValue, 26, 25, 0, // Skip to: 1161
/* 1136 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1139 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1153
/* 1143 */    MCD::OPC_CheckField, 5, 8, 0, 183, 21, // Skip to: 6708
/* 1149 */    MCD::OPC_Decode, 156, 6, 8, // Opcode: UMULCCrr
/* 1153 */    MCD::OPC_FilterValue, 1, 175, 21, // Skip to: 6708
/* 1157 */    MCD::OPC_Decode, 155, 6, 9, // Opcode: UMULCCri
/* 1161 */    MCD::OPC_FilterValue, 27, 25, 0, // Skip to: 1190
/* 1165 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1168 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1182
/* 1172 */    MCD::OPC_CheckField, 5, 8, 0, 154, 21, // Skip to: 6708
/* 1178 */    MCD::OPC_Decode, 182, 5, 8, // Opcode: SMULCCrr
/* 1182 */    MCD::OPC_FilterValue, 1, 146, 21, // Skip to: 6708
/* 1186 */    MCD::OPC_Decode, 181, 5, 9, // Opcode: SMULCCri
/* 1190 */    MCD::OPC_FilterValue, 28, 25, 0, // Skip to: 1219
/* 1194 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1197 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1211
/* 1201 */    MCD::OPC_CheckField, 5, 8, 0, 125, 21, // Skip to: 6708
/* 1207 */    MCD::OPC_Decode, 245, 5, 8, // Opcode: SUBErr
/* 1211 */    MCD::OPC_FilterValue, 1, 117, 21, // Skip to: 6708
/* 1215 */    MCD::OPC_Decode, 244, 5, 9, // Opcode: SUBEri
/* 1219 */    MCD::OPC_FilterValue, 30, 25, 0, // Skip to: 1248
/* 1223 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1226 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1240
/* 1230 */    MCD::OPC_CheckField, 5, 8, 0, 96, 21, // Skip to: 6708
/* 1236 */    MCD::OPC_Decode, 148, 6, 8, // Opcode: UDIVCCrr
/* 1240 */    MCD::OPC_FilterValue, 1, 88, 21, // Skip to: 6708
/* 1244 */    MCD::OPC_Decode, 147, 6, 9, // Opcode: UDIVCCri
/* 1248 */    MCD::OPC_FilterValue, 31, 25, 0, // Skip to: 1277
/* 1252 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1255 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1269
/* 1259 */    MCD::OPC_CheckField, 5, 8, 0, 67, 21, // Skip to: 6708
/* 1265 */    MCD::OPC_Decode, 166, 5, 8, // Opcode: SDIVCCrr
/* 1269 */    MCD::OPC_FilterValue, 1, 59, 21, // Skip to: 6708
/* 1273 */    MCD::OPC_Decode, 165, 5, 9, // Opcode: SDIVCCri
/* 1277 */    MCD::OPC_FilterValue, 32, 25, 0, // Skip to: 1306
/* 1281 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1284 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1298
/* 1288 */    MCD::OPC_CheckField, 5, 8, 0, 38, 21, // Skip to: 6708
/* 1294 */    MCD::OPC_Decode, 130, 6, 8, // Opcode: TADDCCrr
/* 1298 */    MCD::OPC_FilterValue, 1, 30, 21, // Skip to: 6708
/* 1302 */    MCD::OPC_Decode, 129, 6, 9, // Opcode: TADDCCri
/* 1306 */    MCD::OPC_FilterValue, 33, 25, 0, // Skip to: 1335
/* 1310 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1313 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1327
/* 1317 */    MCD::OPC_CheckField, 5, 8, 0, 9, 21, // Skip to: 6708
/* 1323 */    MCD::OPC_Decode, 144, 6, 8, // Opcode: TSUBCCrr
/* 1327 */    MCD::OPC_FilterValue, 1, 1, 21, // Skip to: 6708
/* 1331 */    MCD::OPC_Decode, 143, 6, 9, // Opcode: TSUBCCri
/* 1335 */    MCD::OPC_FilterValue, 34, 25, 0, // Skip to: 1364
/* 1339 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1342 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1356
/* 1346 */    MCD::OPC_CheckField, 5, 8, 0, 236, 20, // Skip to: 6708
/* 1352 */    MCD::OPC_Decode, 128, 6, 8, // Opcode: TADDCCTVrr
/* 1356 */    MCD::OPC_FilterValue, 1, 228, 20, // Skip to: 6708
/* 1360 */    MCD::OPC_Decode, 255, 5, 9, // Opcode: TADDCCTVri
/* 1364 */    MCD::OPC_FilterValue, 35, 25, 0, // Skip to: 1393
/* 1368 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1371 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1385
/* 1375 */    MCD::OPC_CheckField, 5, 8, 0, 207, 20, // Skip to: 6708
/* 1381 */    MCD::OPC_Decode, 142, 6, 8, // Opcode: TSUBCCTVrr
/* 1385 */    MCD::OPC_FilterValue, 1, 199, 20, // Skip to: 6708
/* 1389 */    MCD::OPC_Decode, 141, 6, 9, // Opcode: TSUBCCTVri
/* 1393 */    MCD::OPC_FilterValue, 36, 25, 0, // Skip to: 1422
/* 1397 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1400 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1414
/* 1404 */    MCD::OPC_CheckField, 5, 8, 0, 178, 20, // Skip to: 6708
/* 1410 */    MCD::OPC_Decode, 253, 4, 8, // Opcode: MULSCCrr
/* 1414 */    MCD::OPC_FilterValue, 1, 170, 20, // Skip to: 6708
/* 1418 */    MCD::OPC_Decode, 252, 4, 9, // Opcode: MULSCCri
/* 1422 */    MCD::OPC_FilterValue, 37, 35, 0, // Skip to: 1461
/* 1426 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1429 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1437
/* 1433 */    MCD::OPC_Decode, 178, 5, 8, // Opcode: SLLrr
/* 1437 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1445
/* 1441 */    MCD::OPC_Decode, 176, 5, 12, // Opcode: SLLXrr
/* 1445 */    MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 1453
/* 1449 */    MCD::OPC_Decode, 177, 5, 13, // Opcode: SLLri
/* 1453 */    MCD::OPC_FilterValue, 3, 131, 20, // Skip to: 6708
/* 1457 */    MCD::OPC_Decode, 175, 5, 14, // Opcode: SLLXri
/* 1461 */    MCD::OPC_FilterValue, 38, 35, 0, // Skip to: 1500
/* 1465 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1468 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1476
/* 1472 */    MCD::OPC_Decode, 192, 5, 8, // Opcode: SRLrr
/* 1476 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1484
/* 1480 */    MCD::OPC_Decode, 190, 5, 12, // Opcode: SRLXrr
/* 1484 */    MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 1492
/* 1488 */    MCD::OPC_Decode, 191, 5, 13, // Opcode: SRLri
/* 1492 */    MCD::OPC_FilterValue, 3, 92, 20, // Skip to: 6708
/* 1496 */    MCD::OPC_Decode, 189, 5, 14, // Opcode: SRLXri
/* 1500 */    MCD::OPC_FilterValue, 39, 35, 0, // Skip to: 1539
/* 1504 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1507 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1515
/* 1511 */    MCD::OPC_Decode, 188, 5, 8, // Opcode: SRArr
/* 1515 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1523
/* 1519 */    MCD::OPC_Decode, 186, 5, 12, // Opcode: SRAXrr
/* 1523 */    MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 1531
/* 1527 */    MCD::OPC_Decode, 187, 5, 13, // Opcode: SRAri
/* 1531 */    MCD::OPC_FilterValue, 3, 53, 20, // Skip to: 6708
/* 1535 */    MCD::OPC_Decode, 185, 5, 14, // Opcode: SRAXri
/* 1539 */    MCD::OPC_FilterValue, 40, 58, 0, // Skip to: 1601
/* 1543 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1546 */    MCD::OPC_FilterValue, 0, 27, 0, // Skip to: 1577
/* 1550 */    MCD::OPC_ExtractField, 0, 13,  // Inst{12-0} ...
/* 1553 */    MCD::OPC_FilterValue, 0, 31, 20, // Skip to: 6708
/* 1557 */    MCD::OPC_CheckField, 25, 5, 0, 10, 0, // Skip to: 1573
/* 1563 */    MCD::OPC_CheckField, 14, 5, 15, 4, 0, // Skip to: 1573
/* 1569 */    MCD::OPC_Decode, 195, 5, 4, // Opcode: STBAR
/* 1573 */    MCD::OPC_Decode, 148, 5, 15, // Opcode: RDASR
/* 1577 */    MCD::OPC_FilterValue, 1, 7, 20, // Skip to: 6708
/* 1581 */    MCD::OPC_CheckPredicate, 0, 3, 20, // Skip to: 6708
/* 1585 */    MCD::OPC_CheckField, 25, 5, 0, 253, 19, // Skip to: 6708
/* 1591 */    MCD::OPC_CheckField, 14, 5, 15, 247, 19, // Skip to: 6708
/* 1597 */    MCD::OPC_Decode, 238, 4, 16, // Opcode: MEMBARi
/* 1601 */    MCD::OPC_FilterValue, 41, 10, 0, // Skip to: 1615
/* 1605 */    MCD::OPC_CheckField, 0, 19, 0, 233, 19, // Skip to: 6708
/* 1611 */    MCD::OPC_Decode, 151, 5, 17, // Opcode: RDPSR
/* 1615 */    MCD::OPC_FilterValue, 42, 38, 0, // Skip to: 1657
/* 1619 */    MCD::OPC_ExtractField, 0, 14,  // Inst{13-0} ...
/* 1622 */    MCD::OPC_FilterValue, 0, 218, 19, // Skip to: 6708
/* 1626 */    MCD::OPC_ExtractField, 14, 5,  // Inst{18-14} ...
/* 1629 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1637
/* 1633 */    MCD::OPC_Decode, 153, 5, 17, // Opcode: RDWIM
/* 1637 */    MCD::OPC_FilterValue, 15, 8, 0, // Skip to: 1649
/* 1641 */    MCD::OPC_CheckPredicate, 0, 4, 0, // Skip to: 1649
/* 1645 */    MCD::OPC_Decode, 149, 5, 17, // Opcode: RDFQ
/* 1649 */    MCD::OPC_CheckPredicate, 0, 191, 19, // Skip to: 6708
/* 1653 */    MCD::OPC_Decode, 150, 5, 18, // Opcode: RDPR
/* 1657 */    MCD::OPC_FilterValue, 43, 25, 0, // Skip to: 1686
/* 1661 */    MCD::OPC_ExtractField, 0, 19,  // Inst{18-0} ...
/* 1664 */    MCD::OPC_FilterValue, 0, 176, 19, // Skip to: 6708
/* 1668 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 1682
/* 1672 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, // Skip to: 1682
/* 1678 */    MCD::OPC_Decode, 198, 3, 4, // Opcode: FLUSHW
/* 1682 */    MCD::OPC_Decode, 152, 5, 17, // Opcode: RDTBR
/* 1686 */    MCD::OPC_FilterValue, 44, 123, 0, // Skip to: 1813
/* 1690 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1693 */    MCD::OPC_FilterValue, 0, 56, 0, // Skip to: 1753
/* 1697 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 1700 */    MCD::OPC_FilterValue, 0, 22, 0, // Skip to: 1726
/* 1704 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 1718
/* 1708 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 1718
/* 1714 */    MCD::OPC_Decode, 241, 4, 19, // Opcode: MOVFCCrr
/* 1718 */    MCD::OPC_CheckPredicate, 0, 122, 19, // Skip to: 6708
/* 1722 */    MCD::OPC_Decode, 171, 6, 20, // Opcode: V9MOVFCCrr
/* 1726 */    MCD::OPC_FilterValue, 1, 114, 19, // Skip to: 6708
/* 1730 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 1733 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1745
/* 1737 */    MCD::OPC_CheckPredicate, 0, 103, 19, // Skip to: 6708
/* 1741 */    MCD::OPC_Decode, 243, 4, 19, // Opcode: MOVICCrr
/* 1745 */    MCD::OPC_FilterValue, 2, 95, 19, // Skip to: 6708
/* 1749 */    MCD::OPC_Decode, 250, 4, 19, // Opcode: MOVXCCrr
/* 1753 */    MCD::OPC_FilterValue, 1, 87, 19, // Skip to: 6708
/* 1757 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 1760 */    MCD::OPC_FilterValue, 0, 22, 0, // Skip to: 1786
/* 1764 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 1778
/* 1768 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 1778
/* 1774 */    MCD::OPC_Decode, 240, 4, 21, // Opcode: MOVFCCri
/* 1778 */    MCD::OPC_CheckPredicate, 0, 62, 19, // Skip to: 6708
/* 1782 */    MCD::OPC_Decode, 170, 6, 22, // Opcode: V9MOVFCCri
/* 1786 */    MCD::OPC_FilterValue, 1, 54, 19, // Skip to: 6708
/* 1790 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 1793 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1805
/* 1797 */    MCD::OPC_CheckPredicate, 0, 43, 19, // Skip to: 6708
/* 1801 */    MCD::OPC_Decode, 242, 4, 21, // Opcode: MOVICCri
/* 1805 */    MCD::OPC_FilterValue, 2, 35, 19, // Skip to: 6708
/* 1809 */    MCD::OPC_Decode, 249, 4, 21, // Opcode: MOVXCCri
/* 1813 */    MCD::OPC_FilterValue, 45, 25, 0, // Skip to: 1842
/* 1817 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1820 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1834
/* 1824 */    MCD::OPC_CheckField, 5, 8, 0, 14, 19, // Skip to: 6708
/* 1830 */    MCD::OPC_Decode, 168, 5, 10, // Opcode: SDIVXrr
/* 1834 */    MCD::OPC_FilterValue, 1, 6, 19, // Skip to: 6708
/* 1838 */    MCD::OPC_Decode, 167, 5, 11, // Opcode: SDIVXri
/* 1842 */    MCD::OPC_FilterValue, 46, 14, 0, // Skip to: 1860
/* 1846 */    MCD::OPC_CheckPredicate, 0, 250, 18, // Skip to: 6708
/* 1850 */    MCD::OPC_CheckField, 5, 14, 0, 244, 18, // Skip to: 6708
/* 1856 */    MCD::OPC_Decode, 141, 5, 23, // Opcode: POPCrr
/* 1860 */    MCD::OPC_FilterValue, 47, 25, 0, // Skip to: 1889
/* 1864 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1867 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1881
/* 1871 */    MCD::OPC_CheckField, 5, 5, 0, 223, 18, // Skip to: 6708
/* 1877 */    MCD::OPC_Decode, 245, 4, 24, // Opcode: MOVRrr
/* 1881 */    MCD::OPC_FilterValue, 1, 215, 18, // Skip to: 6708
/* 1885 */    MCD::OPC_Decode, 244, 4, 25, // Opcode: MOVRri
/* 1889 */    MCD::OPC_FilterValue, 48, 45, 0, // Skip to: 1938
/* 1893 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1896 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1910
/* 1900 */    MCD::OPC_CheckField, 5, 8, 0, 194, 18, // Skip to: 6708
/* 1906 */    MCD::OPC_Decode, 173, 6, 26, // Opcode: WRASRrr
/* 1910 */    MCD::OPC_FilterValue, 1, 186, 18, // Skip to: 6708
/* 1914 */    MCD::OPC_CheckPredicate, 0, 16, 0, // Skip to: 1934
/* 1918 */    MCD::OPC_CheckField, 25, 5, 15, 10, 0, // Skip to: 1934
/* 1924 */    MCD::OPC_CheckField, 14, 5, 0, 4, 0, // Skip to: 1934
/* 1930 */    MCD::OPC_Decode, 174, 5, 27, // Opcode: SIR
/* 1934 */    MCD::OPC_Decode, 172, 6, 28, // Opcode: WRASRri
/* 1938 */    MCD::OPC_FilterValue, 49, 183, 0, // Skip to: 2125
/* 1942 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 1945 */    MCD::OPC_FilterValue, 0, 46, 0, // Skip to: 1995
/* 1949 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1952 */    MCD::OPC_FilterValue, 0, 31, 0, // Skip to: 1987
/* 1956 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 1959 */    MCD::OPC_FilterValue, 0, 137, 18, // Skip to: 6708
/* 1963 */    MCD::OPC_CheckPredicate, 0, 16, 0, // Skip to: 1983
/* 1967 */    MCD::OPC_CheckField, 14, 5, 0, 10, 0, // Skip to: 1983
/* 1973 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, // Skip to: 1983
/* 1979 */    MCD::OPC_Decode, 162, 5, 4, // Opcode: SAVED
/* 1983 */    MCD::OPC_Decode, 177, 6, 29, // Opcode: WRPSRrr
/* 1987 */    MCD::OPC_FilterValue, 1, 109, 18, // Skip to: 6708
/* 1991 */    MCD::OPC_Decode, 176, 6, 30, // Opcode: WRPSRri
/* 1995 */    MCD::OPC_FilterValue, 1, 54, 0, // Skip to: 2053
/* 1999 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2002 */    MCD::OPC_FilterValue, 0, 35, 0, // Skip to: 2041
/* 2006 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 2009 */    MCD::OPC_FilterValue, 0, 87, 18, // Skip to: 6708
/* 2013 */    MCD::OPC_CheckPredicate, 0, 16, 0, // Skip to: 2033
/* 2017 */    MCD::OPC_CheckField, 14, 5, 0, 10, 0, // Skip to: 2033
/* 2023 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, // Skip to: 2033
/* 2029 */    MCD::OPC_Decode, 154, 5, 4, // Opcode: RESTORED
/* 2033 */    MCD::OPC_CheckPredicate, 1, 63, 18, // Skip to: 6708
/* 2037 */    MCD::OPC_Decode, 147, 5, 29, // Opcode: PWRPSRrr
/* 2041 */    MCD::OPC_FilterValue, 1, 55, 18, // Skip to: 6708
/* 2045 */    MCD::OPC_CheckPredicate, 1, 51, 18, // Skip to: 6708
/* 2049 */    MCD::OPC_Decode, 146, 5, 30, // Opcode: PWRPSRri
/* 2053 */    MCD::OPC_FilterValue, 2, 14, 0, // Skip to: 2071
/* 2057 */    MCD::OPC_CheckPredicate, 2, 39, 18, // Skip to: 6708
/* 2061 */    MCD::OPC_CheckField, 0, 19, 0, 33, 18, // Skip to: 6708
/* 2067 */    MCD::OPC_Decode, 212, 2, 4, // Opcode: ALLCLEAN
/* 2071 */    MCD::OPC_FilterValue, 3, 14, 0, // Skip to: 2089
/* 2075 */    MCD::OPC_CheckPredicate, 2, 21, 18, // Skip to: 6708
/* 2079 */    MCD::OPC_CheckField, 0, 19, 0, 15, 18, // Skip to: 6708
/* 2085 */    MCD::OPC_Decode, 138, 5, 4, // Opcode: OTHERW
/* 2089 */    MCD::OPC_FilterValue, 4, 14, 0, // Skip to: 2107
/* 2093 */    MCD::OPC_CheckPredicate, 2, 3, 18, // Skip to: 6708
/* 2097 */    MCD::OPC_CheckField, 0, 19, 0, 253, 17, // Skip to: 6708
/* 2103 */    MCD::OPC_Decode, 129, 5, 4, // Opcode: NORMALW
/* 2107 */    MCD::OPC_FilterValue, 5, 245, 17, // Skip to: 6708
/* 2111 */    MCD::OPC_CheckPredicate, 2, 241, 17, // Skip to: 6708
/* 2115 */    MCD::OPC_CheckField, 0, 19, 0, 235, 17, // Skip to: 6708
/* 2121 */    MCD::OPC_Decode, 176, 4, 4, // Opcode: INVALW
/* 2125 */    MCD::OPC_FilterValue, 50, 54, 0, // Skip to: 2183
/* 2129 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2132 */    MCD::OPC_FilterValue, 0, 25, 0, // Skip to: 2161
/* 2136 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 2139 */    MCD::OPC_FilterValue, 0, 213, 17, // Skip to: 6708
/* 2143 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, // Skip to: 2153
/* 2149 */    MCD::OPC_Decode, 181, 6, 29, // Opcode: WRWIMrr
/* 2153 */    MCD::OPC_CheckPredicate, 0, 199, 17, // Skip to: 6708
/* 2157 */    MCD::OPC_Decode, 175, 6, 31, // Opcode: WRPRrr
/* 2161 */    MCD::OPC_FilterValue, 1, 191, 17, // Skip to: 6708
/* 2165 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, // Skip to: 2175
/* 2171 */    MCD::OPC_Decode, 180, 6, 30, // Opcode: WRWIMri
/* 2175 */    MCD::OPC_CheckPredicate, 0, 177, 17, // Skip to: 6708
/* 2179 */    MCD::OPC_Decode, 174, 6, 32, // Opcode: WRPRri
/* 2183 */    MCD::OPC_FilterValue, 51, 37, 0, // Skip to: 2224
/* 2187 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2190 */    MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 2210
/* 2194 */    MCD::OPC_CheckField, 25, 5, 0, 156, 17, // Skip to: 6708
/* 2200 */    MCD::OPC_CheckField, 5, 8, 0, 150, 17, // Skip to: 6708
/* 2206 */    MCD::OPC_Decode, 179, 6, 29, // Opcode: WRTBRrr
/* 2210 */    MCD::OPC_FilterValue, 1, 142, 17, // Skip to: 6708
/* 2214 */    MCD::OPC_CheckField, 25, 5, 0, 136, 17, // Skip to: 6708
/* 2220 */    MCD::OPC_Decode, 178, 6, 30, // Opcode: WRTBRri
/* 2224 */    MCD::OPC_FilterValue, 52, 197, 2, // Skip to: 2937
/* 2228 */    MCD::OPC_ExtractField, 5, 9,  // Inst{13-5} ...
/* 2231 */    MCD::OPC_FilterValue, 1, 10, 0, // Skip to: 2245
/* 2235 */    MCD::OPC_CheckField, 14, 5, 0, 115, 17, // Skip to: 6708
/* 2241 */    MCD::OPC_Decode, 213, 3, 33, // Opcode: FMOVS
/* 2245 */    MCD::OPC_FilterValue, 2, 14, 0, // Skip to: 2263
/* 2249 */    MCD::OPC_CheckPredicate, 0, 103, 17, // Skip to: 6708
/* 2253 */    MCD::OPC_CheckField, 14, 5, 0, 97, 17, // Skip to: 6708
/* 2259 */    MCD::OPC_Decode, 202, 3, 34, // Opcode: FMOVD
/* 2263 */    MCD::OPC_FilterValue, 3, 14, 0, // Skip to: 2281
/* 2267 */    MCD::OPC_CheckPredicate, 0, 85, 17, // Skip to: 6708
/* 2271 */    MCD::OPC_CheckField, 14, 5, 0, 79, 17, // Skip to: 6708
/* 2277 */    MCD::OPC_Decode, 206, 3, 35, // Opcode: FMOVQ
/* 2281 */    MCD::OPC_FilterValue, 5, 10, 0, // Skip to: 2295
/* 2285 */    MCD::OPC_CheckField, 14, 5, 0, 65, 17, // Skip to: 6708
/* 2291 */    MCD::OPC_Decode, 233, 3, 33, // Opcode: FNEGS
/* 2295 */    MCD::OPC_FilterValue, 6, 14, 0, // Skip to: 2313
/* 2299 */    MCD::OPC_CheckPredicate, 0, 53, 17, // Skip to: 6708
/* 2303 */    MCD::OPC_CheckField, 14, 5, 0, 47, 17, // Skip to: 6708
/* 2309 */    MCD::OPC_Decode, 231, 3, 34, // Opcode: FNEGD
/* 2313 */    MCD::OPC_FilterValue, 7, 14, 0, // Skip to: 2331
/* 2317 */    MCD::OPC_CheckPredicate, 0, 35, 17, // Skip to: 6708
/* 2321 */    MCD::OPC_CheckField, 14, 5, 0, 29, 17, // Skip to: 6708
/* 2327 */    MCD::OPC_Decode, 232, 3, 35, // Opcode: FNEGQ
/* 2331 */    MCD::OPC_FilterValue, 9, 10, 0, // Skip to: 2345
/* 2335 */    MCD::OPC_CheckField, 14, 5, 0, 15, 17, // Skip to: 6708
/* 2341 */    MCD::OPC_Decode, 149, 3, 33, // Opcode: FABSS
/* 2345 */    MCD::OPC_FilterValue, 10, 14, 0, // Skip to: 2363
/* 2349 */    MCD::OPC_CheckPredicate, 0, 3, 17, // Skip to: 6708
/* 2353 */    MCD::OPC_CheckField, 14, 5, 0, 253, 16, // Skip to: 6708
/* 2359 */    MCD::OPC_Decode, 147, 3, 34, // Opcode: FABSD
/* 2363 */    MCD::OPC_FilterValue, 11, 14, 0, // Skip to: 2381
/* 2367 */    MCD::OPC_CheckPredicate, 0, 241, 16, // Skip to: 6708
/* 2371 */    MCD::OPC_CheckField, 14, 5, 0, 235, 16, // Skip to: 6708
/* 2377 */    MCD::OPC_Decode, 148, 3, 35, // Opcode: FABSQ
/* 2381 */    MCD::OPC_FilterValue, 41, 10, 0, // Skip to: 2395
/* 2385 */    MCD::OPC_CheckField, 14, 5, 0, 221, 16, // Skip to: 6708
/* 2391 */    MCD::OPC_Decode, 149, 4, 33, // Opcode: FSQRTS
/* 2395 */    MCD::OPC_FilterValue, 42, 10, 0, // Skip to: 2409
/* 2399 */    MCD::OPC_CheckField, 14, 5, 0, 207, 16, // Skip to: 6708
/* 2405 */    MCD::OPC_Decode, 147, 4, 34, // Opcode: FSQRTD
/* 2409 */    MCD::OPC_FilterValue, 43, 10, 0, // Skip to: 2423
/* 2413 */    MCD::OPC_CheckField, 14, 5, 0, 193, 16, // Skip to: 6708
/* 2419 */    MCD::OPC_Decode, 148, 4, 35, // Opcode: FSQRTQ
/* 2423 */    MCD::OPC_FilterValue, 65, 4, 0, // Skip to: 2431
/* 2427 */    MCD::OPC_Decode, 152, 3, 36, // Opcode: FADDS
/* 2431 */    MCD::OPC_FilterValue, 66, 4, 0, // Skip to: 2439
/* 2435 */    MCD::OPC_Decode, 150, 3, 37, // Opcode: FADDD
/* 2439 */    MCD::OPC_FilterValue, 67, 4, 0, // Skip to: 2447
/* 2443 */    MCD::OPC_Decode, 151, 3, 38, // Opcode: FADDQ
/* 2447 */    MCD::OPC_FilterValue, 69, 4, 0, // Skip to: 2455
/* 2451 */    MCD::OPC_Decode, 164, 4, 36, // Opcode: FSUBS
/* 2455 */    MCD::OPC_FilterValue, 70, 4, 0, // Skip to: 2463
/* 2459 */    MCD::OPC_Decode, 162, 4, 37, // Opcode: FSUBD
/* 2463 */    MCD::OPC_FilterValue, 71, 4, 0, // Skip to: 2471
/* 2467 */    MCD::OPC_Decode, 163, 4, 38, // Opcode: FSUBQ
/* 2471 */    MCD::OPC_FilterValue, 73, 4, 0, // Skip to: 2479
/* 2475 */    MCD::OPC_Decode, 226, 3, 36, // Opcode: FMULS
/* 2479 */    MCD::OPC_FilterValue, 74, 4, 0, // Skip to: 2487
/* 2483 */    MCD::OPC_Decode, 222, 3, 37, // Opcode: FMULD
/* 2487 */    MCD::OPC_FilterValue, 75, 4, 0, // Skip to: 2495
/* 2491 */    MCD::OPC_Decode, 225, 3, 38, // Opcode: FMULQ
/* 2495 */    MCD::OPC_FilterValue, 77, 4, 0, // Skip to: 2503
/* 2499 */    MCD::OPC_Decode, 181, 3, 36, // Opcode: FDIVS
/* 2503 */    MCD::OPC_FilterValue, 78, 4, 0, // Skip to: 2511
/* 2507 */    MCD::OPC_Decode, 179, 3, 37, // Opcode: FDIVD
/* 2511 */    MCD::OPC_FilterValue, 79, 4, 0, // Skip to: 2519
/* 2515 */    MCD::OPC_Decode, 180, 3, 38, // Opcode: FDIVQ
/* 2519 */    MCD::OPC_FilterValue, 81, 8, 0, // Skip to: 2531
/* 2523 */    MCD::OPC_CheckPredicate, 3, 85, 16, // Skip to: 6708
/* 2527 */    MCD::OPC_Decode, 228, 3, 36, // Opcode: FNADDS
/* 2531 */    MCD::OPC_FilterValue, 82, 8, 0, // Skip to: 2543
/* 2535 */    MCD::OPC_CheckPredicate, 3, 73, 16, // Skip to: 6708
/* 2539 */    MCD::OPC_Decode, 227, 3, 37, // Opcode: FNADDD
/* 2543 */    MCD::OPC_FilterValue, 89, 8, 0, // Skip to: 2555
/* 2547 */    MCD::OPC_CheckPredicate, 3, 61, 16, // Skip to: 6708
/* 2551 */    MCD::OPC_Decode, 237, 3, 36, // Opcode: FNMULS
/* 2555 */    MCD::OPC_FilterValue, 90, 8, 0, // Skip to: 2567
/* 2559 */    MCD::OPC_CheckPredicate, 3, 49, 16, // Skip to: 6708
/* 2563 */    MCD::OPC_Decode, 236, 3, 37, // Opcode: FNMULD
/* 2567 */    MCD::OPC_FilterValue, 97, 8, 0, // Skip to: 2579
/* 2571 */    MCD::OPC_CheckPredicate, 3, 37, 16, // Skip to: 6708
/* 2575 */    MCD::OPC_Decode, 189, 3, 36, // Opcode: FHADDS
/* 2579 */    MCD::OPC_FilterValue, 98, 8, 0, // Skip to: 2591
/* 2583 */    MCD::OPC_CheckPredicate, 3, 25, 16, // Skip to: 6708
/* 2587 */    MCD::OPC_Decode, 188, 3, 37, // Opcode: FHADDD
/* 2591 */    MCD::OPC_FilterValue, 101, 8, 0, // Skip to: 2603
/* 2595 */    MCD::OPC_CheckPredicate, 3, 13, 16, // Skip to: 6708
/* 2599 */    MCD::OPC_Decode, 191, 3, 36, // Opcode: FHSUBS
/* 2603 */    MCD::OPC_FilterValue, 102, 8, 0, // Skip to: 2615
/* 2607 */    MCD::OPC_CheckPredicate, 3, 1, 16, // Skip to: 6708
/* 2611 */    MCD::OPC_Decode, 190, 3, 37, // Opcode: FHSUBD
/* 2615 */    MCD::OPC_FilterValue, 105, 4, 0, // Skip to: 2623
/* 2619 */    MCD::OPC_Decode, 146, 4, 39, // Opcode: FSMULD
/* 2623 */    MCD::OPC_FilterValue, 110, 4, 0, // Skip to: 2631
/* 2627 */    MCD::OPC_Decode, 182, 3, 40, // Opcode: FDMULQ
/* 2631 */    MCD::OPC_FilterValue, 113, 8, 0, // Skip to: 2643
/* 2635 */    MCD::OPC_CheckPredicate, 3, 229, 15, // Skip to: 6708
/* 2639 */    MCD::OPC_Decode, 235, 3, 36, // Opcode: FNHADDS
/* 2643 */    MCD::OPC_FilterValue, 114, 8, 0, // Skip to: 2655
/* 2647 */    MCD::OPC_CheckPredicate, 3, 217, 15, // Skip to: 6708
/* 2651 */    MCD::OPC_Decode, 234, 3, 37, // Opcode: FNHADDD
/* 2655 */    MCD::OPC_FilterValue, 121, 8, 0, // Skip to: 2667
/* 2659 */    MCD::OPC_CheckPredicate, 3, 205, 15, // Skip to: 6708
/* 2663 */    MCD::OPC_Decode, 244, 3, 39, // Opcode: FNSMULD
/* 2667 */    MCD::OPC_FilterValue, 129, 1, 10, 0, // Skip to: 2682
/* 2672 */    MCD::OPC_CheckField, 14, 5, 0, 190, 15, // Skip to: 6708
/* 2678 */    MCD::OPC_Decode, 161, 4, 41, // Opcode: FSTOX
/* 2682 */    MCD::OPC_FilterValue, 130, 1, 10, 0, // Skip to: 2697
/* 2687 */    MCD::OPC_CheckField, 14, 5, 0, 175, 15, // Skip to: 6708
/* 2693 */    MCD::OPC_Decode, 186, 3, 34, // Opcode: FDTOX
/* 2697 */    MCD::OPC_FilterValue, 131, 1, 10, 0, // Skip to: 2712
/* 2702 */    MCD::OPC_CheckField, 14, 5, 0, 160, 15, // Skip to: 6708
/* 2708 */    MCD::OPC_Decode, 141, 4, 42, // Opcode: FQTOX
/* 2712 */    MCD::OPC_FilterValue, 132, 1, 10, 0, // Skip to: 2727
/* 2717 */    MCD::OPC_CheckField, 14, 5, 0, 145, 15, // Skip to: 6708
/* 2723 */    MCD::OPC_Decode, 171, 4, 43, // Opcode: FXTOS
/* 2727 */    MCD::OPC_FilterValue, 136, 1, 10, 0, // Skip to: 2742
/* 2732 */    MCD::OPC_CheckField, 14, 5, 0, 130, 15, // Skip to: 6708
/* 2738 */    MCD::OPC_Decode, 169, 4, 34, // Opcode: FXTOD
/* 2742 */    MCD::OPC_FilterValue, 140, 1, 10, 0, // Skip to: 2757
/* 2747 */    MCD::OPC_CheckField, 14, 5, 0, 115, 15, // Skip to: 6708
/* 2753 */    MCD::OPC_Decode, 170, 4, 44, // Opcode: FXTOQ
/* 2757 */    MCD::OPC_FilterValue, 196, 1, 10, 0, // Skip to: 2772
/* 2762 */    MCD::OPC_CheckField, 14, 5, 0, 100, 15, // Skip to: 6708
/* 2768 */    MCD::OPC_Decode, 194, 3, 33, // Opcode: FITOS
/* 2772 */    MCD::OPC_FilterValue, 198, 1, 10, 0, // Skip to: 2787
/* 2777 */    MCD::OPC_CheckField, 14, 5, 0, 85, 15, // Skip to: 6708
/* 2783 */    MCD::OPC_Decode, 185, 3, 43, // Opcode: FDTOS
/* 2787 */    MCD::OPC_FilterValue, 199, 1, 10, 0, // Skip to: 2802
/* 2792 */    MCD::OPC_CheckField, 14, 5, 0, 70, 15, // Skip to: 6708
/* 2798 */    MCD::OPC_Decode, 140, 4, 45, // Opcode: FQTOS
/* 2802 */    MCD::OPC_FilterValue, 200, 1, 10, 0, // Skip to: 2817
/* 2807 */    MCD::OPC_CheckField, 14, 5, 0, 55, 15, // Skip to: 6708
/* 2813 */    MCD::OPC_Decode, 192, 3, 41, // Opcode: FITOD
/* 2817 */    MCD::OPC_FilterValue, 201, 1, 10, 0, // Skip to: 2832
/* 2822 */    MCD::OPC_CheckField, 14, 5, 0, 40, 15, // Skip to: 6708
/* 2828 */    MCD::OPC_Decode, 158, 4, 41, // Opcode: FSTOD
/* 2832 */    MCD::OPC_FilterValue, 203, 1, 10, 0, // Skip to: 2847
/* 2837 */    MCD::OPC_CheckField, 14, 5, 0, 25, 15, // Skip to: 6708
/* 2843 */    MCD::OPC_Decode, 138, 4, 42, // Opcode: FQTOD
/* 2847 */    MCD::OPC_FilterValue, 204, 1, 10, 0, // Skip to: 2862
/* 2852 */    MCD::OPC_CheckField, 14, 5, 0, 10, 15, // Skip to: 6708
/* 2858 */    MCD::OPC_Decode, 193, 3, 46, // Opcode: FITOQ
/* 2862 */    MCD::OPC_FilterValue, 205, 1, 10, 0, // Skip to: 2877
/* 2867 */    MCD::OPC_CheckField, 14, 5, 0, 251, 14, // Skip to: 6708
/* 2873 */    MCD::OPC_Decode, 160, 4, 46, // Opcode: FSTOQ
/* 2877 */    MCD::OPC_FilterValue, 206, 1, 10, 0, // Skip to: 2892
/* 2882 */    MCD::OPC_CheckField, 14, 5, 0, 236, 14, // Skip to: 6708
/* 2888 */    MCD::OPC_Decode, 184, 3, 44, // Opcode: FDTOQ
/* 2892 */    MCD::OPC_FilterValue, 209, 1, 10, 0, // Skip to: 2907
/* 2897 */    MCD::OPC_CheckField, 14, 5, 0, 221, 14, // Skip to: 6708
/* 2903 */    MCD::OPC_Decode, 159, 4, 33, // Opcode: FSTOI
/* 2907 */    MCD::OPC_FilterValue, 210, 1, 10, 0, // Skip to: 2922
/* 2912 */    MCD::OPC_CheckField, 14, 5, 0, 206, 14, // Skip to: 6708
/* 2918 */    MCD::OPC_Decode, 183, 3, 43, // Opcode: FDTOI
/* 2922 */    MCD::OPC_FilterValue, 211, 1, 197, 14, // Skip to: 6708
/* 2927 */    MCD::OPC_CheckField, 14, 5, 0, 191, 14, // Skip to: 6708
/* 2933 */    MCD::OPC_Decode, 139, 4, 45, // Opcode: FQTOI
/* 2937 */    MCD::OPC_FilterValue, 53, 131, 1, // Skip to: 3328
/* 2941 */    MCD::OPC_ExtractField, 5, 5,  // Inst{9-5} ...
/* 2944 */    MCD::OPC_FilterValue, 1, 82, 0, // Skip to: 3030
/* 2948 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2951 */    MCD::OPC_FilterValue, 0, 36, 0, // Skip to: 2991
/* 2955 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 2958 */    MCD::OPC_FilterValue, 0, 162, 14, // Skip to: 6708
/* 2962 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 2965 */    MCD::OPC_FilterValue, 0, 155, 14, // Skip to: 6708
/* 2969 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 2983
/* 2973 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 2983
/* 2979 */    MCD::OPC_Decode, 214, 3, 47, // Opcode: FMOVS_FCC
/* 2983 */    MCD::OPC_CheckPredicate, 0, 137, 14, // Skip to: 6708
/* 2987 */    MCD::OPC_Decode, 169, 6, 48, // Opcode: V9FMOVS_FCC
/* 2991 */    MCD::OPC_FilterValue, 1, 129, 14, // Skip to: 6708
/* 2995 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 2998 */    MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 3016
/* 3002 */    MCD::OPC_CheckPredicate, 0, 118, 14, // Skip to: 6708
/* 3006 */    MCD::OPC_CheckField, 18, 1, 0, 112, 14, // Skip to: 6708
/* 3012 */    MCD::OPC_Decode, 215, 3, 47, // Opcode: FMOVS_ICC
/* 3016 */    MCD::OPC_FilterValue, 4, 104, 14, // Skip to: 6708
/* 3020 */    MCD::OPC_CheckField, 18, 1, 0, 98, 14, // Skip to: 6708
/* 3026 */    MCD::OPC_Decode, 216, 3, 47, // Opcode: FMOVS_XCC
/* 3030 */    MCD::OPC_FilterValue, 2, 82, 0, // Skip to: 3116
/* 3034 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 3037 */    MCD::OPC_FilterValue, 0, 36, 0, // Skip to: 3077
/* 3041 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 3044 */    MCD::OPC_FilterValue, 0, 76, 14, // Skip to: 6708
/* 3048 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 3051 */    MCD::OPC_FilterValue, 0, 69, 14, // Skip to: 6708
/* 3055 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 3069
/* 3059 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 3069
/* 3065 */    MCD::OPC_Decode, 203, 3, 49, // Opcode: FMOVD_FCC
/* 3069 */    MCD::OPC_CheckPredicate, 0, 51, 14, // Skip to: 6708
/* 3073 */    MCD::OPC_Decode, 167, 6, 50, // Opcode: V9FMOVD_FCC
/* 3077 */    MCD::OPC_FilterValue, 1, 43, 14, // Skip to: 6708
/* 3081 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 3084 */    MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 3102
/* 3088 */    MCD::OPC_CheckPredicate, 0, 32, 14, // Skip to: 6708
/* 3092 */    MCD::OPC_CheckField, 18, 1, 0, 26, 14, // Skip to: 6708
/* 3098 */    MCD::OPC_Decode, 204, 3, 49, // Opcode: FMOVD_ICC
/* 3102 */    MCD::OPC_FilterValue, 4, 18, 14, // Skip to: 6708
/* 3106 */    MCD::OPC_CheckField, 18, 1, 0, 12, 14, // Skip to: 6708
/* 3112 */    MCD::OPC_Decode, 205, 3, 49, // Opcode: FMOVD_XCC
/* 3116 */    MCD::OPC_FilterValue, 3, 82, 0, // Skip to: 3202
/* 3120 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 3123 */    MCD::OPC_FilterValue, 0, 36, 0, // Skip to: 3163
/* 3127 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 3130 */    MCD::OPC_FilterValue, 0, 246, 13, // Skip to: 6708
/* 3134 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 3137 */    MCD::OPC_FilterValue, 0, 239, 13, // Skip to: 6708
/* 3141 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 3155
/* 3145 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 3155
/* 3151 */    MCD::OPC_Decode, 207, 3, 51, // Opcode: FMOVQ_FCC
/* 3155 */    MCD::OPC_CheckPredicate, 0, 221, 13, // Skip to: 6708
/* 3159 */    MCD::OPC_Decode, 168, 6, 52, // Opcode: V9FMOVQ_FCC
/* 3163 */    MCD::OPC_FilterValue, 1, 213, 13, // Skip to: 6708
/* 3167 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 3170 */    MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 3188
/* 3174 */    MCD::OPC_CheckPredicate, 0, 202, 13, // Skip to: 6708
/* 3178 */    MCD::OPC_CheckField, 18, 1, 0, 196, 13, // Skip to: 6708
/* 3184 */    MCD::OPC_Decode, 208, 3, 51, // Opcode: FMOVQ_ICC
/* 3188 */    MCD::OPC_FilterValue, 4, 188, 13, // Skip to: 6708
/* 3192 */    MCD::OPC_CheckField, 18, 1, 0, 182, 13, // Skip to: 6708
/* 3198 */    MCD::OPC_Decode, 209, 3, 51, // Opcode: FMOVQ_XCC
/* 3202 */    MCD::OPC_FilterValue, 5, 10, 0, // Skip to: 3216
/* 3206 */    MCD::OPC_CheckField, 13, 1, 0, 168, 13, // Skip to: 6708
/* 3212 */    MCD::OPC_Decode, 212, 3, 53, // Opcode: FMOVRS
/* 3216 */    MCD::OPC_FilterValue, 6, 10, 0, // Skip to: 3230
/* 3220 */    MCD::OPC_CheckField, 13, 1, 0, 154, 13, // Skip to: 6708
/* 3226 */    MCD::OPC_Decode, 210, 3, 54, // Opcode: FMOVRD
/* 3230 */    MCD::OPC_FilterValue, 7, 10, 0, // Skip to: 3244
/* 3234 */    MCD::OPC_CheckField, 13, 1, 0, 140, 13, // Skip to: 6708
/* 3240 */    MCD::OPC_Decode, 211, 3, 55, // Opcode: FMOVRQ
/* 3244 */    MCD::OPC_FilterValue, 17, 10, 0, // Skip to: 3258
/* 3248 */    MCD::OPC_CheckField, 10, 4, 2, 126, 13, // Skip to: 6708
/* 3254 */    MCD::OPC_Decode, 166, 6, 56, // Opcode: V9FCMPS
/* 3258 */    MCD::OPC_FilterValue, 18, 10, 0, // Skip to: 3272
/* 3262 */    MCD::OPC_CheckField, 10, 4, 2, 112, 13, // Skip to: 6708
/* 3268 */    MCD::OPC_Decode, 161, 6, 57, // Opcode: V9FCMPD
/* 3272 */    MCD::OPC_FilterValue, 19, 10, 0, // Skip to: 3286
/* 3276 */    MCD::OPC_CheckField, 10, 4, 2, 98, 13, // Skip to: 6708
/* 3282 */    MCD::OPC_Decode, 165, 6, 58, // Opcode: V9FCMPQ
/* 3286 */    MCD::OPC_FilterValue, 21, 10, 0, // Skip to: 3300
/* 3290 */    MCD::OPC_CheckField, 10, 4, 2, 84, 13, // Skip to: 6708
/* 3296 */    MCD::OPC_Decode, 164, 6, 56, // Opcode: V9FCMPES
/* 3300 */    MCD::OPC_FilterValue, 22, 10, 0, // Skip to: 3314
/* 3304 */    MCD::OPC_CheckField, 10, 4, 2, 70, 13, // Skip to: 6708
/* 3310 */    MCD::OPC_Decode, 162, 6, 57, // Opcode: V9FCMPED
/* 3314 */    MCD::OPC_FilterValue, 23, 62, 13, // Skip to: 6708
/* 3318 */    MCD::OPC_CheckField, 10, 4, 2, 56, 13, // Skip to: 6708
/* 3324 */    MCD::OPC_Decode, 163, 6, 58, // Opcode: V9FCMPEQ
/* 3328 */    MCD::OPC_FilterValue, 54, 32, 6, // Skip to: 4900
/* 3332 */    MCD::OPC_ExtractField, 5, 9,  // Inst{13-5} ...
/* 3335 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 3347
/* 3339 */    MCD::OPC_CheckPredicate, 4, 37, 13, // Skip to: 6708
/* 3343 */    MCD::OPC_Decode, 143, 3, 10, // Opcode: EDGE8
/* 3347 */    MCD::OPC_FilterValue, 1, 8, 0, // Skip to: 3359
/* 3351 */    MCD::OPC_CheckPredicate, 5, 25, 13, // Skip to: 6708
/* 3355 */    MCD::OPC_Decode, 146, 3, 10, // Opcode: EDGE8N
/* 3359 */    MCD::OPC_FilterValue, 2, 8, 0, // Skip to: 3371
/* 3363 */    MCD::OPC_CheckPredicate, 4, 13, 13, // Skip to: 6708
/* 3367 */    MCD::OPC_Decode, 144, 3, 10, // Opcode: EDGE8L
/* 3371 */    MCD::OPC_FilterValue, 3, 8, 0, // Skip to: 3383
/* 3375 */    MCD::OPC_CheckPredicate, 5, 1, 13, // Skip to: 6708
/* 3379 */    MCD::OPC_Decode, 145, 3, 10, // Opcode: EDGE8LN
/* 3383 */    MCD::OPC_FilterValue, 4, 8, 0, // Skip to: 3395
/* 3387 */    MCD::OPC_CheckPredicate, 4, 245, 12, // Skip to: 6708
/* 3391 */    MCD::OPC_Decode, 135, 3, 10, // Opcode: EDGE16
/* 3395 */    MCD::OPC_FilterValue, 5, 8, 0, // Skip to: 3407
/* 3399 */    MCD::OPC_CheckPredicate, 5, 233, 12, // Skip to: 6708
/* 3403 */    MCD::OPC_Decode, 138, 3, 10, // Opcode: EDGE16N
/* 3407 */    MCD::OPC_FilterValue, 6, 8, 0, // Skip to: 3419
/* 3411 */    MCD::OPC_CheckPredicate, 4, 221, 12, // Skip to: 6708
/* 3415 */    MCD::OPC_Decode, 136, 3, 10, // Opcode: EDGE16L
/* 3419 */    MCD::OPC_FilterValue, 7, 8, 0, // Skip to: 3431
/* 3423 */    MCD::OPC_CheckPredicate, 5, 209, 12, // Skip to: 6708
/* 3427 */    MCD::OPC_Decode, 137, 3, 10, // Opcode: EDGE16LN
/* 3431 */    MCD::OPC_FilterValue, 8, 8, 0, // Skip to: 3443
/* 3435 */    MCD::OPC_CheckPredicate, 4, 197, 12, // Skip to: 6708
/* 3439 */    MCD::OPC_Decode, 139, 3, 10, // Opcode: EDGE32
/* 3443 */    MCD::OPC_FilterValue, 9, 8, 0, // Skip to: 3455
/* 3447 */    MCD::OPC_CheckPredicate, 5, 185, 12, // Skip to: 6708
/* 3451 */    MCD::OPC_Decode, 142, 3, 10, // Opcode: EDGE32N
/* 3455 */    MCD::OPC_FilterValue, 10, 8, 0, // Skip to: 3467
/* 3459 */    MCD::OPC_CheckPredicate, 4, 173, 12, // Skip to: 6708
/* 3463 */    MCD::OPC_Decode, 140, 3, 10, // Opcode: EDGE32L
/* 3467 */    MCD::OPC_FilterValue, 11, 8, 0, // Skip to: 3479
/* 3471 */    MCD::OPC_CheckPredicate, 5, 161, 12, // Skip to: 6708
/* 3475 */    MCD::OPC_Decode, 141, 3, 10, // Opcode: EDGE32LN
/* 3479 */    MCD::OPC_FilterValue, 16, 8, 0, // Skip to: 3491
/* 3483 */    MCD::OPC_CheckPredicate, 4, 149, 12, // Skip to: 6708
/* 3487 */    MCD::OPC_Decode, 223, 2, 10, // Opcode: ARRAY8
/* 3491 */    MCD::OPC_FilterValue, 17, 8, 0, // Skip to: 3503
/* 3495 */    MCD::OPC_CheckPredicate, 3, 137, 12, // Skip to: 6708
/* 3499 */    MCD::OPC_Decode, 206, 2, 10, // Opcode: ADDXC
/* 3503 */    MCD::OPC_FilterValue, 18, 8, 0, // Skip to: 3515
/* 3507 */    MCD::OPC_CheckPredicate, 4, 125, 12, // Skip to: 6708
/* 3511 */    MCD::OPC_Decode, 221, 2, 10, // Opcode: ARRAY16
/* 3515 */    MCD::OPC_FilterValue, 19, 8, 0, // Skip to: 3527
/* 3519 */    MCD::OPC_CheckPredicate, 3, 113, 12, // Skip to: 6708
/* 3523 */    MCD::OPC_Decode, 207, 2, 10, // Opcode: ADDXCCC
/* 3527 */    MCD::OPC_FilterValue, 20, 8, 0, // Skip to: 3539
/* 3531 */    MCD::OPC_CheckPredicate, 4, 101, 12, // Skip to: 6708
/* 3535 */    MCD::OPC_Decode, 222, 2, 10, // Opcode: ARRAY32
/* 3539 */    MCD::OPC_FilterValue, 22, 8, 0, // Skip to: 3551
/* 3543 */    MCD::OPC_CheckPredicate, 3, 89, 12, // Skip to: 6708
/* 3547 */    MCD::OPC_Decode, 157, 6, 10, // Opcode: UMULXHI
/* 3551 */    MCD::OPC_FilterValue, 23, 14, 0, // Skip to: 3569
/* 3555 */    MCD::OPC_CheckPredicate, 3, 77, 12, // Skip to: 6708
/* 3559 */    MCD::OPC_CheckField, 14, 5, 0, 71, 12, // Skip to: 6708
/* 3565 */    MCD::OPC_Decode, 237, 4, 59, // Opcode: LZCNT
/* 3569 */    MCD::OPC_FilterValue, 24, 8, 0, // Skip to: 3581
/* 3573 */    MCD::OPC_CheckPredicate, 4, 59, 12, // Skip to: 6708
/* 3577 */    MCD::OPC_Decode, 210, 2, 10, // Opcode: ALIGNADDR
/* 3581 */    MCD::OPC_FilterValue, 25, 8, 0, // Skip to: 3593
/* 3585 */    MCD::OPC_CheckPredicate, 5, 47, 12, // Skip to: 6708
/* 3589 */    MCD::OPC_Decode, 229, 2, 10, // Opcode: BMASK
/* 3593 */    MCD::OPC_FilterValue, 26, 8, 0, // Skip to: 3605
/* 3597 */    MCD::OPC_CheckPredicate, 4, 35, 12, // Skip to: 6708
/* 3601 */    MCD::OPC_Decode, 211, 2, 10, // Opcode: ALIGNADDRL
/* 3605 */    MCD::OPC_FilterValue, 27, 20, 0, // Skip to: 3629
/* 3609 */    MCD::OPC_CheckPredicate, 3, 23, 12, // Skip to: 6708
/* 3613 */    MCD::OPC_CheckField, 25, 5, 0, 17, 12, // Skip to: 6708
/* 3619 */    MCD::OPC_CheckField, 14, 5, 0, 11, 12, // Skip to: 6708
/* 3625 */    MCD::OPC_Decode, 133, 3, 60, // Opcode: CMASK8
/* 3629 */    MCD::OPC_FilterValue, 29, 20, 0, // Skip to: 3653
/* 3633 */    MCD::OPC_CheckPredicate, 3, 255, 11, // Skip to: 6708
/* 3637 */    MCD::OPC_CheckField, 25, 5, 0, 249, 11, // Skip to: 6708
/* 3643 */    MCD::OPC_CheckField, 14, 5, 0, 243, 11, // Skip to: 6708
/* 3649 */    MCD::OPC_Decode, 131, 3, 60, // Opcode: CMASK16
/* 3653 */    MCD::OPC_FilterValue, 31, 20, 0, // Skip to: 3677
/* 3657 */    MCD::OPC_CheckPredicate, 3, 231, 11, // Skip to: 6708
/* 3661 */    MCD::OPC_CheckField, 25, 5, 0, 225, 11, // Skip to: 6708
/* 3667 */    MCD::OPC_CheckField, 14, 5, 0, 219, 11, // Skip to: 6708
/* 3673 */    MCD::OPC_Decode, 132, 3, 60, // Opcode: CMASK32
/* 3677 */    MCD::OPC_FilterValue, 32, 8, 0, // Skip to: 3689
/* 3681 */    MCD::OPC_CheckPredicate, 4, 207, 11, // Skip to: 6708
/* 3685 */    MCD::OPC_Decode, 171, 3, 61, // Opcode: FCMPLE16
/* 3689 */    MCD::OPC_FilterValue, 33, 8, 0, // Skip to: 3701
/* 3693 */    MCD::OPC_CheckPredicate, 3, 195, 11, // Skip to: 6708
/* 3697 */    MCD::OPC_Decode, 144, 4, 37, // Opcode: FSLL16
/* 3701 */    MCD::OPC_FilterValue, 34, 8, 0, // Skip to: 3713
/* 3705 */    MCD::OPC_CheckPredicate, 4, 183, 11, // Skip to: 6708
/* 3709 */    MCD::OPC_Decode, 173, 3, 61, // Opcode: FCMPNE16
/* 3713 */    MCD::OPC_FilterValue, 35, 8, 0, // Skip to: 3725
/* 3717 */    MCD::OPC_CheckPredicate, 3, 171, 11, // Skip to: 6708
/* 3721 */    MCD::OPC_Decode, 156, 4, 37, // Opcode: FSRL16
/* 3725 */    MCD::OPC_FilterValue, 36, 8, 0, // Skip to: 3737
/* 3729 */    MCD::OPC_CheckPredicate, 4, 159, 11, // Skip to: 6708
/* 3733 */    MCD::OPC_Decode, 172, 3, 61, // Opcode: FCMPLE32
/* 3737 */    MCD::OPC_FilterValue, 37, 8, 0, // Skip to: 3749
/* 3741 */    MCD::OPC_CheckPredicate, 3, 147, 11, // Skip to: 6708
/* 3745 */    MCD::OPC_Decode, 145, 4, 37, // Opcode: FSLL32
/* 3749 */    MCD::OPC_FilterValue, 38, 8, 0, // Skip to: 3761
/* 3753 */    MCD::OPC_CheckPredicate, 4, 135, 11, // Skip to: 6708
/* 3757 */    MCD::OPC_Decode, 174, 3, 61, // Opcode: FCMPNE32
/* 3761 */    MCD::OPC_FilterValue, 39, 8, 0, // Skip to: 3773
/* 3765 */    MCD::OPC_CheckPredicate, 3, 123, 11, // Skip to: 6708
/* 3769 */    MCD::OPC_Decode, 157, 4, 37, // Opcode: FSRL32
/* 3773 */    MCD::OPC_FilterValue, 40, 8, 0, // Skip to: 3785
/* 3777 */    MCD::OPC_CheckPredicate, 4, 111, 11, // Skip to: 6708
/* 3781 */    MCD::OPC_Decode, 169, 3, 61, // Opcode: FCMPGT16
/* 3785 */    MCD::OPC_FilterValue, 41, 8, 0, // Skip to: 3797
/* 3789 */    MCD::OPC_CheckPredicate, 3, 99, 11, // Skip to: 6708
/* 3793 */    MCD::OPC_Decode, 142, 4, 37, // Opcode: FSLAS16
/* 3797 */    MCD::OPC_FilterValue, 42, 8, 0, // Skip to: 3809
/* 3801 */    MCD::OPC_CheckPredicate, 4, 87, 11, // Skip to: 6708
/* 3805 */    MCD::OPC_Decode, 167, 3, 61, // Opcode: FCMPEQ16
/* 3809 */    MCD::OPC_FilterValue, 43, 8, 0, // Skip to: 3821
/* 3813 */    MCD::OPC_CheckPredicate, 3, 75, 11, // Skip to: 6708
/* 3817 */    MCD::OPC_Decode, 150, 4, 37, // Opcode: FSRA16
/* 3821 */    MCD::OPC_FilterValue, 44, 8, 0, // Skip to: 3833
/* 3825 */    MCD::OPC_CheckPredicate, 4, 63, 11, // Skip to: 6708
/* 3829 */    MCD::OPC_Decode, 170, 3, 61, // Opcode: FCMPGT32
/* 3833 */    MCD::OPC_FilterValue, 45, 8, 0, // Skip to: 3845
/* 3837 */    MCD::OPC_CheckPredicate, 3, 51, 11, // Skip to: 6708
/* 3841 */    MCD::OPC_Decode, 143, 4, 37, // Opcode: FSLAS32
/* 3845 */    MCD::OPC_FilterValue, 46, 8, 0, // Skip to: 3857
/* 3849 */    MCD::OPC_CheckPredicate, 4, 39, 11, // Skip to: 6708
/* 3853 */    MCD::OPC_Decode, 168, 3, 61, // Opcode: FCMPEQ32
/* 3857 */    MCD::OPC_FilterValue, 47, 8, 0, // Skip to: 3869
/* 3861 */    MCD::OPC_CheckPredicate, 3, 27, 11, // Skip to: 6708
/* 3865 */    MCD::OPC_Decode, 151, 4, 37, // Opcode: FSRA32
/* 3869 */    MCD::OPC_FilterValue, 49, 8, 0, // Skip to: 3881
/* 3873 */    MCD::OPC_CheckPredicate, 4, 15, 11, // Skip to: 6708
/* 3877 */    MCD::OPC_Decode, 219, 3, 62, // Opcode: FMUL8X16
/* 3881 */    MCD::OPC_FilterValue, 51, 8, 0, // Skip to: 3893
/* 3885 */    MCD::OPC_CheckPredicate, 4, 3, 11, // Skip to: 6708
/* 3889 */    MCD::OPC_Decode, 221, 3, 39, // Opcode: FMUL8X16AU
/* 3893 */    MCD::OPC_FilterValue, 53, 8, 0, // Skip to: 3905
/* 3897 */    MCD::OPC_CheckPredicate, 4, 247, 10, // Skip to: 6708
/* 3901 */    MCD::OPC_Decode, 220, 3, 39, // Opcode: FMUL8X16AL
/* 3905 */    MCD::OPC_FilterValue, 54, 8, 0, // Skip to: 3917
/* 3909 */    MCD::OPC_CheckPredicate, 4, 235, 10, // Skip to: 6708
/* 3913 */    MCD::OPC_Decode, 217, 3, 37, // Opcode: FMUL8SUX16
/* 3917 */    MCD::OPC_FilterValue, 55, 8, 0, // Skip to: 3929
/* 3921 */    MCD::OPC_CheckPredicate, 4, 223, 10, // Skip to: 6708
/* 3925 */    MCD::OPC_Decode, 218, 3, 37, // Opcode: FMUL8ULX16
/* 3929 */    MCD::OPC_FilterValue, 56, 8, 0, // Skip to: 3941
/* 3933 */    MCD::OPC_CheckPredicate, 4, 211, 10, // Skip to: 6708
/* 3937 */    MCD::OPC_Decode, 223, 3, 39, // Opcode: FMULD8SUX16
/* 3941 */    MCD::OPC_FilterValue, 57, 8, 0, // Skip to: 3953
/* 3945 */    MCD::OPC_CheckPredicate, 4, 199, 10, // Skip to: 6708
/* 3949 */    MCD::OPC_Decode, 224, 3, 39, // Opcode: FMULD8ULX16
/* 3953 */    MCD::OPC_FilterValue, 58, 8, 0, // Skip to: 3965
/* 3957 */    MCD::OPC_CheckPredicate, 4, 187, 10, // Skip to: 6708
/* 3961 */    MCD::OPC_Decode, 254, 3, 37, // Opcode: FPACK32
/* 3965 */    MCD::OPC_FilterValue, 59, 14, 0, // Skip to: 3983
/* 3969 */    MCD::OPC_CheckPredicate, 4, 175, 10, // Skip to: 6708
/* 3973 */    MCD::OPC_CheckField, 14, 5, 0, 169, 10, // Skip to: 6708
/* 3979 */    MCD::OPC_Decode, 253, 3, 34, // Opcode: FPACK16
/* 3983 */    MCD::OPC_FilterValue, 61, 14, 0, // Skip to: 4001
/* 3987 */    MCD::OPC_CheckPredicate, 4, 157, 10, // Skip to: 6708
/* 3991 */    MCD::OPC_CheckField, 14, 5, 0, 151, 10, // Skip to: 6708
/* 3997 */    MCD::OPC_Decode, 255, 3, 43, // Opcode: FPACKFIX
/* 4001 */    MCD::OPC_FilterValue, 62, 8, 0, // Skip to: 4013
/* 4005 */    MCD::OPC_CheckPredicate, 4, 139, 10, // Skip to: 6708
/* 4009 */    MCD::OPC_Decode, 139, 5, 37, // Opcode: PDIST
/* 4013 */    MCD::OPC_FilterValue, 63, 8, 0, // Skip to: 4025
/* 4017 */    MCD::OPC_CheckPredicate, 3, 127, 10, // Skip to: 6708
/* 4021 */    MCD::OPC_Decode, 140, 5, 61, // Opcode: PDISTN
/* 4025 */    MCD::OPC_FilterValue, 64, 8, 0, // Skip to: 4037
/* 4029 */    MCD::OPC_CheckPredicate, 3, 115, 10, // Skip to: 6708
/* 4033 */    MCD::OPC_Decode, 201, 3, 37, // Opcode: FMEAN16
/* 4037 */    MCD::OPC_FilterValue, 66, 8, 0, // Skip to: 4049
/* 4041 */    MCD::OPC_CheckPredicate, 3, 103, 10, // Skip to: 6708
/* 4045 */    MCD::OPC_Decode, 132, 4, 37, // Opcode: FPADD64
/* 4049 */    MCD::OPC_FilterValue, 68, 8, 0, // Skip to: 4061
/* 4053 */    MCD::OPC_CheckPredicate, 3, 91, 10, // Skip to: 6708
/* 4057 */    MCD::OPC_Decode, 164, 3, 37, // Opcode: FCHKSM16
/* 4061 */    MCD::OPC_FilterValue, 72, 8, 0, // Skip to: 4073
/* 4065 */    MCD::OPC_CheckPredicate, 4, 79, 10, // Skip to: 6708
/* 4069 */    MCD::OPC_Decode, 153, 3, 37, // Opcode: FALIGNADATA
/* 4073 */    MCD::OPC_FilterValue, 75, 8, 0, // Skip to: 4085
/* 4077 */    MCD::OPC_CheckPredicate, 4, 67, 10, // Skip to: 6708
/* 4081 */    MCD::OPC_Decode, 133, 4, 39, // Opcode: FPMERGE
/* 4085 */    MCD::OPC_FilterValue, 76, 8, 0, // Skip to: 4097
/* 4089 */    MCD::OPC_CheckPredicate, 5, 55, 10, // Skip to: 6708
/* 4093 */    MCD::OPC_Decode, 246, 2, 37, // Opcode: BSHUFFLE
/* 4097 */    MCD::OPC_FilterValue, 77, 14, 0, // Skip to: 4115
/* 4101 */    MCD::OPC_CheckPredicate, 4, 43, 10, // Skip to: 6708
/* 4105 */    MCD::OPC_CheckField, 14, 5, 0, 37, 10, // Skip to: 6708
/* 4111 */    MCD::OPC_Decode, 187, 3, 41, // Opcode: FEXPAND
/* 4115 */    MCD::OPC_FilterValue, 80, 8, 0, // Skip to: 4127
/* 4119 */    MCD::OPC_CheckPredicate, 4, 25, 10, // Skip to: 6708
/* 4123 */    MCD::OPC_Decode, 128, 4, 37, // Opcode: FPADD16
/* 4127 */    MCD::OPC_FilterValue, 81, 8, 0, // Skip to: 4139
/* 4131 */    MCD::OPC_CheckPredicate, 4, 13, 10, // Skip to: 6708
/* 4135 */    MCD::OPC_Decode, 129, 4, 36, // Opcode: FPADD16S
/* 4139 */    MCD::OPC_FilterValue, 82, 8, 0, // Skip to: 4151
/* 4143 */    MCD::OPC_CheckPredicate, 4, 1, 10, // Skip to: 6708
/* 4147 */    MCD::OPC_Decode, 130, 4, 37, // Opcode: FPADD32
/* 4151 */    MCD::OPC_FilterValue, 83, 8, 0, // Skip to: 4163
/* 4155 */    MCD::OPC_CheckPredicate, 4, 245, 9, // Skip to: 6708
/* 4159 */    MCD::OPC_Decode, 131, 4, 36, // Opcode: FPADD32S
/* 4163 */    MCD::OPC_FilterValue, 84, 8, 0, // Skip to: 4175
/* 4167 */    MCD::OPC_CheckPredicate, 4, 233, 9, // Skip to: 6708
/* 4171 */    MCD::OPC_Decode, 134, 4, 37, // Opcode: FPSUB16
/* 4175 */    MCD::OPC_FilterValue, 85, 8, 0, // Skip to: 4187
/* 4179 */    MCD::OPC_CheckPredicate, 4, 221, 9, // Skip to: 6708
/* 4183 */    MCD::OPC_Decode, 135, 4, 36, // Opcode: FPSUB16S
/* 4187 */    MCD::OPC_FilterValue, 86, 8, 0, // Skip to: 4199
/* 4191 */    MCD::OPC_CheckPredicate, 4, 209, 9, // Skip to: 6708
/* 4195 */    MCD::OPC_Decode, 136, 4, 37, // Opcode: FPSUB32
/* 4199 */    MCD::OPC_FilterValue, 87, 8, 0, // Skip to: 4211
/* 4203 */    MCD::OPC_CheckPredicate, 4, 197, 9, // Skip to: 6708
/* 4207 */    MCD::OPC_Decode, 137, 4, 36, // Opcode: FPSUB32S
/* 4211 */    MCD::OPC_FilterValue, 96, 20, 0, // Skip to: 4235
/* 4215 */    MCD::OPC_CheckPredicate, 4, 185, 9, // Skip to: 6708
/* 4219 */    MCD::OPC_CheckField, 14, 5, 0, 179, 9, // Skip to: 6708
/* 4225 */    MCD::OPC_CheckField, 0, 5, 0, 173, 9, // Skip to: 6708
/* 4231 */    MCD::OPC_Decode, 172, 4, 63, // Opcode: FZERO
/* 4235 */    MCD::OPC_FilterValue, 97, 20, 0, // Skip to: 4259
/* 4239 */    MCD::OPC_CheckPredicate, 4, 161, 9, // Skip to: 6708
/* 4243 */    MCD::OPC_CheckField, 14, 5, 0, 155, 9, // Skip to: 6708
/* 4249 */    MCD::OPC_CheckField, 0, 5, 0, 149, 9, // Skip to: 6708
/* 4255 */    MCD::OPC_Decode, 173, 4, 64, // Opcode: FZEROS
/* 4259 */    MCD::OPC_FilterValue, 98, 8, 0, // Skip to: 4271
/* 4263 */    MCD::OPC_CheckPredicate, 4, 137, 9, // Skip to: 6708
/* 4267 */    MCD::OPC_Decode, 238, 3, 37, // Opcode: FNOR
/* 4271 */    MCD::OPC_FilterValue, 99, 8, 0, // Skip to: 4283
/* 4275 */    MCD::OPC_CheckPredicate, 4, 125, 9, // Skip to: 6708
/* 4279 */    MCD::OPC_Decode, 239, 3, 36, // Opcode: FNORS
/* 4283 */    MCD::OPC_FilterValue, 100, 8, 0, // Skip to: 4295
/* 4287 */    MCD::OPC_CheckPredicate, 4, 113, 9, // Skip to: 6708
/* 4291 */    MCD::OPC_Decode, 157, 3, 37, // Opcode: FANDNOT2
/* 4295 */    MCD::OPC_FilterValue, 101, 8, 0, // Skip to: 4307
/* 4299 */    MCD::OPC_CheckPredicate, 4, 101, 9, // Skip to: 6708
/* 4303 */    MCD::OPC_Decode, 158, 3, 36, // Opcode: FANDNOT2S
/* 4307 */    MCD::OPC_FilterValue, 102, 14, 0, // Skip to: 4325
/* 4311 */    MCD::OPC_CheckPredicate, 4, 89, 9, // Skip to: 6708
/* 4315 */    MCD::OPC_CheckField, 14, 5, 0, 83, 9, // Skip to: 6708
/* 4321 */    MCD::OPC_Decode, 242, 3, 34, // Opcode: FNOT2
/* 4325 */    MCD::OPC_FilterValue, 103, 14, 0, // Skip to: 4343
/* 4329 */    MCD::OPC_CheckPredicate, 4, 71, 9, // Skip to: 6708
/* 4333 */    MCD::OPC_CheckField, 14, 5, 0, 65, 9, // Skip to: 6708
/* 4339 */    MCD::OPC_Decode, 243, 3, 33, // Opcode: FNOT2S
/* 4343 */    MCD::OPC_FilterValue, 104, 8, 0, // Skip to: 4355
/* 4347 */    MCD::OPC_CheckPredicate, 4, 53, 9, // Skip to: 6708
/* 4351 */    MCD::OPC_Decode, 155, 3, 37, // Opcode: FANDNOT1
/* 4355 */    MCD::OPC_FilterValue, 105, 8, 0, // Skip to: 4367
/* 4359 */    MCD::OPC_CheckPredicate, 4, 41, 9, // Skip to: 6708
/* 4363 */    MCD::OPC_Decode, 156, 3, 36, // Opcode: FANDNOT1S
/* 4367 */    MCD::OPC_FilterValue, 106, 14, 0, // Skip to: 4385
/* 4371 */    MCD::OPC_CheckPredicate, 4, 29, 9, // Skip to: 6708
/* 4375 */    MCD::OPC_CheckField, 0, 5, 0, 23, 9, // Skip to: 6708
/* 4381 */    MCD::OPC_Decode, 240, 3, 65, // Opcode: FNOT1
/* 4385 */    MCD::OPC_FilterValue, 107, 14, 0, // Skip to: 4403
/* 4389 */    MCD::OPC_CheckPredicate, 4, 11, 9, // Skip to: 6708
/* 4393 */    MCD::OPC_CheckField, 0, 5, 0, 5, 9, // Skip to: 6708
/* 4399 */    MCD::OPC_Decode, 241, 3, 66, // Opcode: FNOT1S
/* 4403 */    MCD::OPC_FilterValue, 108, 8, 0, // Skip to: 4415
/* 4407 */    MCD::OPC_CheckPredicate, 4, 249, 8, // Skip to: 6708
/* 4411 */    MCD::OPC_Decode, 167, 4, 37, // Opcode: FXOR
/* 4415 */    MCD::OPC_FilterValue, 109, 8, 0, // Skip to: 4427
/* 4419 */    MCD::OPC_CheckPredicate, 4, 237, 8, // Skip to: 6708
/* 4423 */    MCD::OPC_Decode, 168, 4, 36, // Opcode: FXORS
/* 4427 */    MCD::OPC_FilterValue, 110, 8, 0, // Skip to: 4439
/* 4431 */    MCD::OPC_CheckPredicate, 4, 225, 8, // Skip to: 6708
/* 4435 */    MCD::OPC_Decode, 229, 3, 37, // Opcode: FNAND
/* 4439 */    MCD::OPC_FilterValue, 111, 8, 0, // Skip to: 4451
/* 4443 */    MCD::OPC_CheckPredicate, 4, 213, 8, // Skip to: 6708
/* 4447 */    MCD::OPC_Decode, 230, 3, 36, // Opcode: FNANDS
/* 4451 */    MCD::OPC_FilterValue, 112, 8, 0, // Skip to: 4463
/* 4455 */    MCD::OPC_CheckPredicate, 4, 201, 8, // Skip to: 6708
/* 4459 */    MCD::OPC_Decode, 154, 3, 37, // Opcode: FAND
/* 4463 */    MCD::OPC_FilterValue, 113, 8, 0, // Skip to: 4475
/* 4467 */    MCD::OPC_CheckPredicate, 4, 189, 8, // Skip to: 6708
/* 4471 */    MCD::OPC_Decode, 159, 3, 36, // Opcode: FANDS
/* 4475 */    MCD::OPC_FilterValue, 114, 8, 0, // Skip to: 4487
/* 4479 */    MCD::OPC_CheckPredicate, 4, 177, 8, // Skip to: 6708
/* 4483 */    MCD::OPC_Decode, 165, 4, 37, // Opcode: FXNOR
/* 4487 */    MCD::OPC_FilterValue, 115, 8, 0, // Skip to: 4499
/* 4491 */    MCD::OPC_CheckPredicate, 4, 165, 8, // Skip to: 6708
/* 4495 */    MCD::OPC_Decode, 166, 4, 36, // Opcode: FXNORS
/* 4499 */    MCD::OPC_FilterValue, 116, 14, 0, // Skip to: 4517
/* 4503 */    MCD::OPC_CheckPredicate, 4, 153, 8, // Skip to: 6708
/* 4507 */    MCD::OPC_CheckField, 0, 5, 0, 147, 8, // Skip to: 6708
/* 4513 */    MCD::OPC_Decode, 152, 4, 65, // Opcode: FSRC1
/* 4517 */    MCD::OPC_FilterValue, 117, 14, 0, // Skip to: 4535
/* 4521 */    MCD::OPC_CheckPredicate, 4, 135, 8, // Skip to: 6708
/* 4525 */    MCD::OPC_CheckField, 0, 5, 0, 129, 8, // Skip to: 6708
/* 4531 */    MCD::OPC_Decode, 153, 4, 66, // Opcode: FSRC1S
/* 4535 */    MCD::OPC_FilterValue, 118, 8, 0, // Skip to: 4547
/* 4539 */    MCD::OPC_CheckPredicate, 4, 117, 8, // Skip to: 6708
/* 4543 */    MCD::OPC_Decode, 250, 3, 37, // Opcode: FORNOT2
/* 4547 */    MCD::OPC_FilterValue, 119, 8, 0, // Skip to: 4559
/* 4551 */    MCD::OPC_CheckPredicate, 4, 105, 8, // Skip to: 6708
/* 4555 */    MCD::OPC_Decode, 251, 3, 36, // Opcode: FORNOT2S
/* 4559 */    MCD::OPC_FilterValue, 120, 14, 0, // Skip to: 4577
/* 4563 */    MCD::OPC_CheckPredicate, 4, 93, 8, // Skip to: 6708
/* 4567 */    MCD::OPC_CheckField, 14, 5, 0, 87, 8, // Skip to: 6708
/* 4573 */    MCD::OPC_Decode, 154, 4, 34, // Opcode: FSRC2
/* 4577 */    MCD::OPC_FilterValue, 121, 14, 0, // Skip to: 4595
/* 4581 */    MCD::OPC_CheckPredicate, 4, 75, 8, // Skip to: 6708
/* 4585 */    MCD::OPC_CheckField, 14, 5, 0, 69, 8, // Skip to: 6708
/* 4591 */    MCD::OPC_Decode, 155, 4, 33, // Opcode: FSRC2S
/* 4595 */    MCD::OPC_FilterValue, 122, 8, 0, // Skip to: 4607
/* 4599 */    MCD::OPC_CheckPredicate, 4, 57, 8, // Skip to: 6708
/* 4603 */    MCD::OPC_Decode, 248, 3, 37, // Opcode: FORNOT1
/* 4607 */    MCD::OPC_FilterValue, 123, 8, 0, // Skip to: 4619
/* 4611 */    MCD::OPC_CheckPredicate, 4, 45, 8, // Skip to: 6708
/* 4615 */    MCD::OPC_Decode, 249, 3, 36, // Opcode: FORNOT1S
/* 4619 */    MCD::OPC_FilterValue, 124, 8, 0, // Skip to: 4631
/* 4623 */    MCD::OPC_CheckPredicate, 4, 33, 8, // Skip to: 6708
/* 4627 */    MCD::OPC_Decode, 247, 3, 37, // Opcode: FOR
/* 4631 */    MCD::OPC_FilterValue, 125, 8, 0, // Skip to: 4643
/* 4635 */    MCD::OPC_CheckPredicate, 4, 21, 8, // Skip to: 6708
/* 4639 */    MCD::OPC_Decode, 252, 3, 36, // Opcode: FORS
/* 4643 */    MCD::OPC_FilterValue, 126, 20, 0, // Skip to: 4667
/* 4647 */    MCD::OPC_CheckPredicate, 4, 9, 8, // Skip to: 6708
/* 4651 */    MCD::OPC_CheckField, 14, 5, 0, 3, 8, // Skip to: 6708
/* 4657 */    MCD::OPC_CheckField, 0, 5, 0, 253, 7, // Skip to: 6708
/* 4663 */    MCD::OPC_Decode, 245, 3, 63, // Opcode: FONE
/* 4667 */    MCD::OPC_FilterValue, 127, 20, 0, // Skip to: 4691
/* 4671 */    MCD::OPC_CheckPredicate, 4, 241, 7, // Skip to: 6708
/* 4675 */    MCD::OPC_CheckField, 14, 5, 0, 235, 7, // Skip to: 6708
/* 4681 */    MCD::OPC_CheckField, 0, 5, 0, 229, 7, // Skip to: 6708
/* 4687 */    MCD::OPC_Decode, 246, 3, 64, // Opcode: FONES
/* 4691 */    MCD::OPC_FilterValue, 128, 1, 26, 0, // Skip to: 4722
/* 4696 */    MCD::OPC_CheckPredicate, 4, 216, 7, // Skip to: 6708
/* 4700 */    MCD::OPC_CheckField, 25, 5, 0, 210, 7, // Skip to: 6708
/* 4706 */    MCD::OPC_CheckField, 14, 5, 0, 204, 7, // Skip to: 6708
/* 4712 */    MCD::OPC_CheckField, 0, 5, 0, 198, 7, // Skip to: 6708
/* 4718 */    MCD::OPC_Decode, 172, 5, 4, // Opcode: SHUTDOWN
/* 4722 */    MCD::OPC_FilterValue, 129, 1, 26, 0, // Skip to: 4753
/* 4727 */    MCD::OPC_CheckPredicate, 5, 185, 7, // Skip to: 6708
/* 4731 */    MCD::OPC_CheckField, 25, 5, 0, 179, 7, // Skip to: 6708
/* 4737 */    MCD::OPC_CheckField, 14, 5, 0, 173, 7, // Skip to: 6708
/* 4743 */    MCD::OPC_CheckField, 3, 2, 0, 167, 7, // Skip to: 6708
/* 4749 */    MCD::OPC_Decode, 173, 5, 67, // Opcode: SIAM
/* 4753 */    MCD::OPC_FilterValue, 144, 2, 14, 0, // Skip to: 4772
/* 4758 */    MCD::OPC_CheckPredicate, 3, 154, 7, // Skip to: 6708
/* 4762 */    MCD::OPC_CheckField, 14, 5, 0, 148, 7, // Skip to: 6708
/* 4768 */    MCD::OPC_Decode, 239, 4, 68, // Opcode: MOVDTOX
/* 4772 */    MCD::OPC_FilterValue, 145, 2, 14, 0, // Skip to: 4791
/* 4777 */    MCD::OPC_CheckPredicate, 3, 135, 7, // Skip to: 6708
/* 4781 */    MCD::OPC_CheckField, 14, 5, 0, 129, 7, // Skip to: 6708
/* 4787 */    MCD::OPC_Decode, 247, 4, 69, // Opcode: MOVSTOUW
/* 4791 */    MCD::OPC_FilterValue, 147, 2, 14, 0, // Skip to: 4810
/* 4796 */    MCD::OPC_CheckPredicate, 3, 116, 7, // Skip to: 6708
/* 4800 */    MCD::OPC_CheckField, 14, 5, 0, 110, 7, // Skip to: 6708
/* 4806 */    MCD::OPC_Decode, 246, 4, 69, // Opcode: MOVSTOSW
/* 4810 */    MCD::OPC_FilterValue, 149, 2, 8, 0, // Skip to: 4823
/* 4815 */    MCD::OPC_CheckPredicate, 3, 97, 7, // Skip to: 6708
/* 4819 */    MCD::OPC_Decode, 182, 6, 10, // Opcode: XMULX
/* 4823 */    MCD::OPC_FilterValue, 150, 2, 8, 0, // Skip to: 4836
/* 4828 */    MCD::OPC_CheckPredicate, 3, 84, 7, // Skip to: 6708
/* 4832 */    MCD::OPC_Decode, 183, 6, 10, // Opcode: XMULXHI
/* 4836 */    MCD::OPC_FilterValue, 152, 2, 14, 0, // Skip to: 4855
/* 4841 */    MCD::OPC_CheckPredicate, 3, 71, 7, // Skip to: 6708
/* 4845 */    MCD::OPC_CheckField, 14, 5, 0, 65, 7, // Skip to: 6708
/* 4851 */    MCD::OPC_Decode, 251, 4, 70, // Opcode: MOVXTOD
/* 4855 */    MCD::OPC_FilterValue, 153, 2, 14, 0, // Skip to: 4874
/* 4860 */    MCD::OPC_CheckPredicate, 3, 52, 7, // Skip to: 6708
/* 4864 */    MCD::OPC_CheckField, 14, 5, 0, 46, 7, // Skip to: 6708
/* 4870 */    MCD::OPC_Decode, 248, 4, 71, // Opcode: MOVWTOS
/* 4874 */    MCD::OPC_FilterValue, 209, 2, 8, 0, // Skip to: 4887
/* 4879 */    MCD::OPC_CheckPredicate, 3, 33, 7, // Skip to: 6708
/* 4883 */    MCD::OPC_Decode, 196, 3, 56, // Opcode: FLCMPS
/* 4887 */    MCD::OPC_FilterValue, 210, 2, 24, 7, // Skip to: 6708
/* 4892 */    MCD::OPC_CheckPredicate, 3, 20, 7, // Skip to: 6708
/* 4896 */    MCD::OPC_Decode, 195, 3, 57, // Opcode: FLCMPD
/* 4900 */    MCD::OPC_FilterValue, 56, 25, 0, // Skip to: 4929
/* 4904 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4907 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 4921
/* 4911 */    MCD::OPC_CheckField, 5, 8, 0, 255, 6, // Skip to: 6708
/* 4917 */    MCD::OPC_Decode, 178, 4, 72, // Opcode: JMPLrr
/* 4921 */    MCD::OPC_FilterValue, 1, 247, 6, // Skip to: 6708
/* 4925 */    MCD::OPC_Decode, 177, 4, 73, // Opcode: JMPLri
/* 4929 */    MCD::OPC_FilterValue, 57, 37, 0, // Skip to: 4970
/* 4933 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4936 */    MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 4956
/* 4940 */    MCD::OPC_CheckField, 25, 5, 0, 226, 6, // Skip to: 6708
/* 4946 */    MCD::OPC_CheckField, 5, 8, 0, 220, 6, // Skip to: 6708
/* 4952 */    MCD::OPC_Decode, 161, 5, 74, // Opcode: RETTrr
/* 4956 */    MCD::OPC_FilterValue, 1, 212, 6, // Skip to: 6708
/* 4960 */    MCD::OPC_CheckField, 25, 5, 0, 206, 6, // Skip to: 6708
/* 4966 */    MCD::OPC_Decode, 160, 5, 75, // Opcode: RETTri
/* 4970 */    MCD::OPC_FilterValue, 58, 104, 0, // Skip to: 5078
/* 4974 */    MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 4977 */    MCD::OPC_FilterValue, 16, 16, 0, // Skip to: 4997
/* 4981 */    MCD::OPC_CheckField, 29, 1, 0, 185, 6, // Skip to: 6708
/* 4987 */    MCD::OPC_CheckField, 5, 3, 0, 179, 6, // Skip to: 6708
/* 4993 */    MCD::OPC_Decode, 146, 6, 76, // Opcode: TXCCrr
/* 4997 */    MCD::OPC_FilterValue, 32, 63, 0, // Skip to: 5064
/* 5001 */    MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 5004 */    MCD::OPC_FilterValue, 1, 16, 0, // Skip to: 5024
/* 5008 */    MCD::OPC_CheckField, 25, 5, 8, 158, 6, // Skip to: 6708
/* 5014 */    MCD::OPC_CheckField, 14, 5, 0, 152, 6, // Skip to: 6708
/* 5020 */    MCD::OPC_Decode, 252, 5, 4, // Opcode: TA1
/* 5024 */    MCD::OPC_FilterValue, 3, 16, 0, // Skip to: 5044
/* 5028 */    MCD::OPC_CheckField, 25, 5, 8, 138, 6, // Skip to: 6708
/* 5034 */    MCD::OPC_CheckField, 14, 5, 0, 132, 6, // Skip to: 6708
/* 5040 */    MCD::OPC_Decode, 253, 5, 4, // Opcode: TA3
/* 5044 */    MCD::OPC_FilterValue, 5, 124, 6, // Skip to: 6708
/* 5048 */    MCD::OPC_CheckField, 25, 5, 8, 118, 6, // Skip to: 6708
/* 5054 */    MCD::OPC_CheckField, 14, 5, 0, 112, 6, // Skip to: 6708
/* 5060 */    MCD::OPC_Decode, 254, 5, 4, // Opcode: TA5
/* 5064 */    MCD::OPC_FilterValue, 48, 104, 6, // Skip to: 6708
/* 5068 */    MCD::OPC_CheckField, 29, 1, 0, 98, 6, // Skip to: 6708
/* 5074 */    MCD::OPC_Decode, 145, 6, 77, // Opcode: TXCCri
/* 5078 */    MCD::OPC_FilterValue, 59, 55, 0, // Skip to: 5137
/* 5082 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5085 */    MCD::OPC_FilterValue, 0, 34, 0, // Skip to: 5123
/* 5089 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 5092 */    MCD::OPC_FilterValue, 0, 76, 6, // Skip to: 6708
/* 5096 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 5099 */    MCD::OPC_FilterValue, 0, 69, 6, // Skip to: 6708
/* 5103 */    MCD::OPC_CheckField, 14, 5, 0, 10, 0, // Skip to: 5119
/* 5109 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, // Skip to: 5119
/* 5115 */    MCD::OPC_Decode, 197, 3, 4, // Opcode: FLUSH
/* 5119 */    MCD::OPC_Decode, 200, 3, 74, // Opcode: FLUSHrr
/* 5123 */    MCD::OPC_FilterValue, 1, 45, 6, // Skip to: 6708
/* 5127 */    MCD::OPC_CheckField, 25, 5, 0, 39, 6, // Skip to: 6708
/* 5133 */    MCD::OPC_Decode, 199, 3, 75, // Opcode: FLUSHri
/* 5137 */    MCD::OPC_FilterValue, 60, 25, 0, // Skip to: 5166
/* 5141 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5144 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5158
/* 5148 */    MCD::OPC_CheckField, 5, 8, 0, 18, 6, // Skip to: 6708
/* 5154 */    MCD::OPC_Decode, 164, 5, 8, // Opcode: SAVErr
/* 5158 */    MCD::OPC_FilterValue, 1, 10, 6, // Skip to: 6708
/* 5162 */    MCD::OPC_Decode, 163, 5, 9, // Opcode: SAVEri
/* 5166 */    MCD::OPC_FilterValue, 61, 25, 0, // Skip to: 5195
/* 5170 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5173 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5187
/* 5177 */    MCD::OPC_CheckField, 5, 8, 0, 245, 5, // Skip to: 6708
/* 5183 */    MCD::OPC_Decode, 156, 5, 8, // Opcode: RESTORErr
/* 5187 */    MCD::OPC_FilterValue, 1, 237, 5, // Skip to: 6708
/* 5191 */    MCD::OPC_Decode, 155, 5, 9, // Opcode: RESTOREri
/* 5195 */    MCD::OPC_FilterValue, 62, 77, 0, // Skip to: 5276
/* 5199 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5202 */    MCD::OPC_FilterValue, 0, 62, 0, // Skip to: 5268
/* 5206 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 5209 */    MCD::OPC_FilterValue, 0, 215, 5, // Skip to: 6708
/* 5213 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 5216 */    MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 5240
/* 5220 */    MCD::OPC_CheckPredicate, 0, 40, 0, // Skip to: 5264
/* 5224 */    MCD::OPC_CheckField, 14, 5, 0, 34, 0, // Skip to: 5264
/* 5230 */    MCD::OPC_CheckField, 0, 5, 0, 28, 0, // Skip to: 5264
/* 5236 */    MCD::OPC_Decode, 134, 3, 4, // Opcode: DONE
/* 5240 */    MCD::OPC_FilterValue, 1, 20, 0, // Skip to: 5264
/* 5244 */    MCD::OPC_CheckPredicate, 0, 16, 0, // Skip to: 5264
/* 5248 */    MCD::OPC_CheckField, 14, 5, 0, 10, 0, // Skip to: 5264
/* 5254 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, // Skip to: 5264
/* 5260 */    MCD::OPC_Decode, 159, 5, 4, // Opcode: RETRY
/* 5264 */    MCD::OPC_Decode, 154, 6, 8, // Opcode: UMACrr
/* 5268 */    MCD::OPC_FilterValue, 1, 156, 5, // Skip to: 6708
/* 5272 */    MCD::OPC_Decode, 153, 6, 9, // Opcode: UMACri
/* 5276 */    MCD::OPC_FilterValue, 63, 148, 5, // Skip to: 6708
/* 5280 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5283 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5297
/* 5287 */    MCD::OPC_CheckField, 5, 8, 0, 135, 5, // Skip to: 6708
/* 5293 */    MCD::OPC_Decode, 180, 5, 8, // Opcode: SMACrr
/* 5297 */    MCD::OPC_FilterValue, 1, 127, 5, // Skip to: 6708
/* 5301 */    MCD::OPC_Decode, 179, 5, 9, // Opcode: SMACri
/* 5305 */    MCD::OPC_FilterValue, 3, 119, 5, // Skip to: 6708
/* 5309 */    MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 5312 */    MCD::OPC_FilterValue, 0, 25, 0, // Skip to: 5341
/* 5316 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5319 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5333
/* 5323 */    MCD::OPC_CheckField, 5, 8, 0, 99, 5, // Skip to: 6708
/* 5329 */    MCD::OPC_Decode, 236, 4, 72, // Opcode: LDrr
/* 5333 */    MCD::OPC_FilterValue, 1, 91, 5, // Skip to: 6708
/* 5337 */    MCD::OPC_Decode, 235, 4, 73, // Opcode: LDri
/* 5341 */    MCD::OPC_FilterValue, 1, 25, 0, // Skip to: 5370
/* 5345 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5348 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5362
/* 5352 */    MCD::OPC_CheckField, 5, 8, 0, 70, 5, // Skip to: 6708
/* 5358 */    MCD::OPC_Decode, 224, 4, 72, // Opcode: LDUBrr
/* 5362 */    MCD::OPC_FilterValue, 1, 62, 5, // Skip to: 6708
/* 5366 */    MCD::OPC_Decode, 223, 4, 73, // Opcode: LDUBri
/* 5370 */    MCD::OPC_FilterValue, 2, 25, 0, // Skip to: 5399
/* 5374 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5377 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5391
/* 5381 */    MCD::OPC_CheckField, 5, 8, 0, 41, 5, // Skip to: 6708
/* 5387 */    MCD::OPC_Decode, 228, 4, 72, // Opcode: LDUHrr
/* 5391 */    MCD::OPC_FilterValue, 1, 33, 5, // Skip to: 6708
/* 5395 */    MCD::OPC_Decode, 227, 4, 73, // Opcode: LDUHri
/* 5399 */    MCD::OPC_FilterValue, 3, 25, 0, // Skip to: 5428
/* 5403 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5406 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5420
/* 5410 */    MCD::OPC_CheckField, 5, 8, 0, 12, 5, // Skip to: 6708
/* 5416 */    MCD::OPC_Decode, 194, 4, 78, // Opcode: LDDrr
/* 5420 */    MCD::OPC_FilterValue, 1, 4, 5, // Skip to: 6708
/* 5424 */    MCD::OPC_Decode, 193, 4, 79, // Opcode: LDDri
/* 5428 */    MCD::OPC_FilterValue, 4, 25, 0, // Skip to: 5457
/* 5432 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5435 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5449
/* 5439 */    MCD::OPC_CheckField, 5, 8, 0, 239, 4, // Skip to: 6708
/* 5445 */    MCD::OPC_Decode, 239, 5, 80, // Opcode: STrr
/* 5449 */    MCD::OPC_FilterValue, 1, 231, 4, // Skip to: 6708
/* 5453 */    MCD::OPC_Decode, 238, 5, 81, // Opcode: STri
/* 5457 */    MCD::OPC_FilterValue, 5, 25, 0, // Skip to: 5486
/* 5461 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5464 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5478
/* 5468 */    MCD::OPC_CheckField, 5, 8, 0, 210, 4, // Skip to: 6708
/* 5474 */    MCD::OPC_Decode, 199, 5, 80, // Opcode: STBrr
/* 5478 */    MCD::OPC_FilterValue, 1, 202, 4, // Skip to: 6708
/* 5482 */    MCD::OPC_Decode, 198, 5, 81, // Opcode: STBri
/* 5486 */    MCD::OPC_FilterValue, 6, 25, 0, // Skip to: 5515
/* 5490 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5493 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5507
/* 5497 */    MCD::OPC_CheckField, 5, 8, 0, 181, 4, // Skip to: 6708
/* 5503 */    MCD::OPC_Decode, 227, 5, 80, // Opcode: STHrr
/* 5507 */    MCD::OPC_FilterValue, 1, 173, 4, // Skip to: 6708
/* 5511 */    MCD::OPC_Decode, 226, 5, 81, // Opcode: STHri
/* 5515 */    MCD::OPC_FilterValue, 7, 25, 0, // Skip to: 5544
/* 5519 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5522 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5536
/* 5526 */    MCD::OPC_CheckField, 5, 8, 0, 152, 4, // Skip to: 6708
/* 5532 */    MCD::OPC_Decode, 217, 5, 82, // Opcode: STDrr
/* 5536 */    MCD::OPC_FilterValue, 1, 144, 4, // Skip to: 6708
/* 5540 */    MCD::OPC_Decode, 216, 5, 83, // Opcode: STDri
/* 5544 */    MCD::OPC_FilterValue, 8, 25, 0, // Skip to: 5573
/* 5548 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5551 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5565
/* 5555 */    MCD::OPC_CheckField, 5, 8, 0, 123, 4, // Skip to: 6708
/* 5561 */    MCD::OPC_Decode, 220, 4, 84, // Opcode: LDSWrr
/* 5565 */    MCD::OPC_FilterValue, 1, 115, 4, // Skip to: 6708
/* 5569 */    MCD::OPC_Decode, 219, 4, 85, // Opcode: LDSWri
/* 5573 */    MCD::OPC_FilterValue, 9, 25, 0, // Skip to: 5602
/* 5577 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5580 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5594
/* 5584 */    MCD::OPC_CheckField, 5, 8, 0, 94, 4, // Skip to: 6708
/* 5590 */    MCD::OPC_Decode, 208, 4, 72, // Opcode: LDSBrr
/* 5594 */    MCD::OPC_FilterValue, 1, 86, 4, // Skip to: 6708
/* 5598 */    MCD::OPC_Decode, 207, 4, 73, // Opcode: LDSBri
/* 5602 */    MCD::OPC_FilterValue, 10, 25, 0, // Skip to: 5631
/* 5606 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5609 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5623
/* 5613 */    MCD::OPC_CheckField, 5, 8, 0, 65, 4, // Skip to: 6708
/* 5619 */    MCD::OPC_Decode, 212, 4, 72, // Opcode: LDSHrr
/* 5623 */    MCD::OPC_FilterValue, 1, 57, 4, // Skip to: 6708
/* 5627 */    MCD::OPC_Decode, 211, 4, 73, // Opcode: LDSHri
/* 5631 */    MCD::OPC_FilterValue, 11, 25, 0, // Skip to: 5660
/* 5635 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5638 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5652
/* 5642 */    MCD::OPC_CheckField, 5, 8, 0, 36, 4, // Skip to: 6708
/* 5648 */    MCD::OPC_Decode, 234, 4, 84, // Opcode: LDXrr
/* 5652 */    MCD::OPC_FilterValue, 1, 28, 4, // Skip to: 6708
/* 5656 */    MCD::OPC_Decode, 233, 4, 85, // Opcode: LDXri
/* 5660 */    MCD::OPC_FilterValue, 13, 25, 0, // Skip to: 5689
/* 5664 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5667 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5681
/* 5671 */    MCD::OPC_CheckField, 5, 8, 0, 7, 4, // Skip to: 6708
/* 5677 */    MCD::OPC_Decode, 216, 4, 72, // Opcode: LDSTUBrr
/* 5681 */    MCD::OPC_FilterValue, 1, 255, 3, // Skip to: 6708
/* 5685 */    MCD::OPC_Decode, 215, 4, 73, // Opcode: LDSTUBri
/* 5689 */    MCD::OPC_FilterValue, 14, 25, 0, // Skip to: 5718
/* 5693 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5696 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5710
/* 5700 */    MCD::OPC_CheckField, 5, 8, 0, 234, 3, // Skip to: 6708
/* 5706 */    MCD::OPC_Decode, 237, 5, 86, // Opcode: STXrr
/* 5710 */    MCD::OPC_FilterValue, 1, 226, 3, // Skip to: 6708
/* 5714 */    MCD::OPC_Decode, 236, 5, 87, // Opcode: STXri
/* 5718 */    MCD::OPC_FilterValue, 15, 25, 0, // Skip to: 5747
/* 5722 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5725 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5739
/* 5729 */    MCD::OPC_CheckField, 5, 8, 0, 205, 3, // Skip to: 6708
/* 5735 */    MCD::OPC_Decode, 251, 5, 88, // Opcode: SWAPrr
/* 5739 */    MCD::OPC_FilterValue, 1, 197, 3, // Skip to: 6708
/* 5743 */    MCD::OPC_Decode, 250, 5, 89, // Opcode: SWAPri
/* 5747 */    MCD::OPC_FilterValue, 16, 23, 0, // Skip to: 5774
/* 5751 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5754 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5762
/* 5758 */    MCD::OPC_Decode, 180, 4, 90, // Opcode: LDArr
/* 5762 */    MCD::OPC_FilterValue, 1, 174, 3, // Skip to: 6708
/* 5766 */    MCD::OPC_CheckPredicate, 0, 170, 3, // Skip to: 6708
/* 5770 */    MCD::OPC_Decode, 179, 4, 73, // Opcode: LDAri
/* 5774 */    MCD::OPC_FilterValue, 17, 23, 0, // Skip to: 5801
/* 5778 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5781 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5789
/* 5785 */    MCD::OPC_Decode, 222, 4, 90, // Opcode: LDUBArr
/* 5789 */    MCD::OPC_FilterValue, 1, 147, 3, // Skip to: 6708
/* 5793 */    MCD::OPC_CheckPredicate, 0, 143, 3, // Skip to: 6708
/* 5797 */    MCD::OPC_Decode, 221, 4, 73, // Opcode: LDUBAri
/* 5801 */    MCD::OPC_FilterValue, 18, 23, 0, // Skip to: 5828
/* 5805 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5808 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5816
/* 5812 */    MCD::OPC_Decode, 226, 4, 90, // Opcode: LDUHArr
/* 5816 */    MCD::OPC_FilterValue, 1, 120, 3, // Skip to: 6708
/* 5820 */    MCD::OPC_CheckPredicate, 0, 116, 3, // Skip to: 6708
/* 5824 */    MCD::OPC_Decode, 225, 4, 73, // Opcode: LDUHAri
/* 5828 */    MCD::OPC_FilterValue, 19, 23, 0, // Skip to: 5855
/* 5832 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5835 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5843
/* 5839 */    MCD::OPC_Decode, 186, 4, 91, // Opcode: LDDArr
/* 5843 */    MCD::OPC_FilterValue, 1, 93, 3, // Skip to: 6708
/* 5847 */    MCD::OPC_CheckPredicate, 0, 89, 3, // Skip to: 6708
/* 5851 */    MCD::OPC_Decode, 185, 4, 79, // Opcode: LDDAri
/* 5855 */    MCD::OPC_FilterValue, 20, 23, 0, // Skip to: 5882
/* 5859 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5862 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5870
/* 5866 */    MCD::OPC_Decode, 194, 5, 92, // Opcode: STArr
/* 5870 */    MCD::OPC_FilterValue, 1, 66, 3, // Skip to: 6708
/* 5874 */    MCD::OPC_CheckPredicate, 0, 62, 3, // Skip to: 6708
/* 5878 */    MCD::OPC_Decode, 193, 5, 81, // Opcode: STAri
/* 5882 */    MCD::OPC_FilterValue, 21, 23, 0, // Skip to: 5909
/* 5886 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5889 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5897
/* 5893 */    MCD::OPC_Decode, 197, 5, 92, // Opcode: STBArr
/* 5897 */    MCD::OPC_FilterValue, 1, 39, 3, // Skip to: 6708
/* 5901 */    MCD::OPC_CheckPredicate, 0, 35, 3, // Skip to: 6708
/* 5905 */    MCD::OPC_Decode, 196, 5, 81, // Opcode: STBAri
/* 5909 */    MCD::OPC_FilterValue, 22, 23, 0, // Skip to: 5936
/* 5913 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5916 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5924
/* 5920 */    MCD::OPC_Decode, 225, 5, 92, // Opcode: STHArr
/* 5924 */    MCD::OPC_FilterValue, 1, 12, 3, // Skip to: 6708
/* 5928 */    MCD::OPC_CheckPredicate, 0, 8, 3, // Skip to: 6708
/* 5932 */    MCD::OPC_Decode, 224, 5, 81, // Opcode: STHAri
/* 5936 */    MCD::OPC_FilterValue, 23, 23, 0, // Skip to: 5963
/* 5940 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5943 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5951
/* 5947 */    MCD::OPC_Decode, 205, 5, 93, // Opcode: STDArr
/* 5951 */    MCD::OPC_FilterValue, 1, 241, 2, // Skip to: 6708
/* 5955 */    MCD::OPC_CheckPredicate, 0, 237, 2, // Skip to: 6708
/* 5959 */    MCD::OPC_Decode, 204, 5, 83, // Opcode: STDAri
/* 5963 */    MCD::OPC_FilterValue, 24, 19, 0, // Skip to: 5986
/* 5967 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5970 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5978
/* 5974 */    MCD::OPC_Decode, 218, 4, 94, // Opcode: LDSWArr
/* 5978 */    MCD::OPC_FilterValue, 1, 214, 2, // Skip to: 6708
/* 5982 */    MCD::OPC_Decode, 217, 4, 85, // Opcode: LDSWAri
/* 5986 */    MCD::OPC_FilterValue, 25, 23, 0, // Skip to: 6013
/* 5990 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5993 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6001
/* 5997 */    MCD::OPC_Decode, 206, 4, 90, // Opcode: LDSBArr
/* 6001 */    MCD::OPC_FilterValue, 1, 191, 2, // Skip to: 6708
/* 6005 */    MCD::OPC_CheckPredicate, 0, 187, 2, // Skip to: 6708
/* 6009 */    MCD::OPC_Decode, 205, 4, 73, // Opcode: LDSBAri
/* 6013 */    MCD::OPC_FilterValue, 26, 23, 0, // Skip to: 6040
/* 6017 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6020 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6028
/* 6024 */    MCD::OPC_Decode, 210, 4, 90, // Opcode: LDSHArr
/* 6028 */    MCD::OPC_FilterValue, 1, 164, 2, // Skip to: 6708
/* 6032 */    MCD::OPC_CheckPredicate, 0, 160, 2, // Skip to: 6708
/* 6036 */    MCD::OPC_Decode, 209, 4, 73, // Opcode: LDSHAri
/* 6040 */    MCD::OPC_FilterValue, 27, 19, 0, // Skip to: 6063
/* 6044 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6047 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6055
/* 6051 */    MCD::OPC_Decode, 230, 4, 94, // Opcode: LDXArr
/* 6055 */    MCD::OPC_FilterValue, 1, 137, 2, // Skip to: 6708
/* 6059 */    MCD::OPC_Decode, 229, 4, 85, // Opcode: LDXAri
/* 6063 */    MCD::OPC_FilterValue, 29, 23, 0, // Skip to: 6090
/* 6067 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6070 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6078
/* 6074 */    MCD::OPC_Decode, 214, 4, 90, // Opcode: LDSTUBArr
/* 6078 */    MCD::OPC_FilterValue, 1, 114, 2, // Skip to: 6708
/* 6082 */    MCD::OPC_CheckPredicate, 0, 110, 2, // Skip to: 6708
/* 6086 */    MCD::OPC_Decode, 213, 4, 73, // Opcode: LDSTUBAri
/* 6090 */    MCD::OPC_FilterValue, 30, 19, 0, // Skip to: 6113
/* 6094 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6097 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6105
/* 6101 */    MCD::OPC_Decode, 233, 5, 95, // Opcode: STXArr
/* 6105 */    MCD::OPC_FilterValue, 1, 87, 2, // Skip to: 6708
/* 6109 */    MCD::OPC_Decode, 232, 5, 87, // Opcode: STXAri
/* 6113 */    MCD::OPC_FilterValue, 31, 23, 0, // Skip to: 6140
/* 6117 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6120 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6128
/* 6124 */    MCD::OPC_Decode, 249, 5, 96, // Opcode: SWAPArr
/* 6128 */    MCD::OPC_FilterValue, 1, 64, 2, // Skip to: 6708
/* 6132 */    MCD::OPC_CheckPredicate, 0, 60, 2, // Skip to: 6708
/* 6136 */    MCD::OPC_Decode, 248, 5, 89, // Opcode: SWAPAri
/* 6140 */    MCD::OPC_FilterValue, 32, 25, 0, // Skip to: 6169
/* 6144 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6147 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 6161
/* 6151 */    MCD::OPC_CheckField, 5, 8, 0, 39, 2, // Skip to: 6708
/* 6157 */    MCD::OPC_Decode, 200, 4, 97, // Opcode: LDFrr
/* 6161 */    MCD::OPC_FilterValue, 1, 31, 2, // Skip to: 6708
/* 6165 */    MCD::OPC_Decode, 199, 4, 98, // Opcode: LDFri
/* 6169 */    MCD::OPC_FilterValue, 33, 69, 0, // Skip to: 6242
/* 6173 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6176 */    MCD::OPC_FilterValue, 0, 35, 0, // Skip to: 6215
/* 6180 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 6183 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 6197
/* 6187 */    MCD::OPC_CheckField, 5, 8, 0, 3, 2, // Skip to: 6708
/* 6193 */    MCD::OPC_Decode, 198, 4, 74, // Opcode: LDFSRrr
/* 6197 */    MCD::OPC_FilterValue, 1, 251, 1, // Skip to: 6708
/* 6201 */    MCD::OPC_CheckPredicate, 0, 247, 1, // Skip to: 6708
/* 6205 */    MCD::OPC_CheckField, 5, 8, 0, 241, 1, // Skip to: 6708
/* 6211 */    MCD::OPC_Decode, 232, 4, 74, // Opcode: LDXFSRrr
/* 6215 */    MCD::OPC_FilterValue, 1, 233, 1, // Skip to: 6708
/* 6219 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 6222 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6230
/* 6226 */    MCD::OPC_Decode, 197, 4, 75, // Opcode: LDFSRri
/* 6230 */    MCD::OPC_FilterValue, 1, 218, 1, // Skip to: 6708
/* 6234 */    MCD::OPC_CheckPredicate, 0, 214, 1, // Skip to: 6708
/* 6238 */    MCD::OPC_Decode, 231, 4, 75, // Opcode: LDXFSRri
/* 6242 */    MCD::OPC_FilterValue, 35, 25, 0, // Skip to: 6271
/* 6246 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6249 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 6263
/* 6253 */    MCD::OPC_CheckField, 5, 8, 0, 193, 1, // Skip to: 6708
/* 6259 */    MCD::OPC_Decode, 192, 4, 99, // Opcode: LDDFrr
/* 6263 */    MCD::OPC_FilterValue, 1, 185, 1, // Skip to: 6708
/* 6267 */    MCD::OPC_Decode, 191, 4, 100, // Opcode: LDDFri
/* 6271 */    MCD::OPC_FilterValue, 36, 25, 0, // Skip to: 6300
/* 6275 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6278 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 6292
/* 6282 */    MCD::OPC_CheckField, 5, 8, 0, 164, 1, // Skip to: 6708
/* 6288 */    MCD::OPC_Decode, 223, 5, 101, // Opcode: STFrr
/* 6292 */    MCD::OPC_FilterValue, 1, 156, 1, // Skip to: 6708
/* 6296 */    MCD::OPC_Decode, 222, 5, 102, // Opcode: STFri
/* 6300 */    MCD::OPC_FilterValue, 37, 69, 0, // Skip to: 6373
/* 6304 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6307 */    MCD::OPC_FilterValue, 0, 35, 0, // Skip to: 6346
/* 6311 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 6314 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 6328
/* 6318 */    MCD::OPC_CheckField, 5, 8, 0, 128, 1, // Skip to: 6708
/* 6324 */    MCD::OPC_Decode, 221, 5, 74, // Opcode: STFSRrr
/* 6328 */    MCD::OPC_FilterValue, 1, 120, 1, // Skip to: 6708
/* 6332 */    MCD::OPC_CheckPredicate, 0, 116, 1, // Skip to: 6708
/* 6336 */    MCD::OPC_CheckField, 5, 8, 0, 110, 1, // Skip to: 6708
/* 6342 */    MCD::OPC_Decode, 235, 5, 74, // Opcode: STXFSRrr
/* 6346 */    MCD::OPC_FilterValue, 1, 102, 1, // Skip to: 6708
/* 6350 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 6353 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 6361
/* 6357 */    MCD::OPC_Decode, 220, 5, 75, // Opcode: STFSRri
/* 6361 */    MCD::OPC_FilterValue, 1, 87, 1, // Skip to: 6708
/* 6365 */    MCD::OPC_CheckPredicate, 0, 83, 1, // Skip to: 6708
/* 6369 */    MCD::OPC_Decode, 234, 5, 75, // Opcode: STXFSRri
/* 6373 */    MCD::OPC_FilterValue, 38, 37, 0, // Skip to: 6414
/* 6377 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6380 */    MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 6400
/* 6384 */    MCD::OPC_CheckField, 25, 5, 0, 62, 1, // Skip to: 6708
/* 6390 */    MCD::OPC_CheckField, 5, 8, 0, 56, 1, // Skip to: 6708
/* 6396 */    MCD::OPC_Decode, 213, 5, 74, // Opcode: STDFQrr
/* 6400 */    MCD::OPC_FilterValue, 1, 48, 1, // Skip to: 6708
/* 6404 */    MCD::OPC_CheckField, 25, 5, 0, 42, 1, // Skip to: 6708
/* 6410 */    MCD::OPC_Decode, 212, 5, 75, // Opcode: STDFQri
/* 6414 */    MCD::OPC_FilterValue, 39, 25, 0, // Skip to: 6443
/* 6418 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6421 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 6435
/* 6425 */    MCD::OPC_CheckField, 5, 8, 0, 21, 1, // Skip to: 6708
/* 6431 */    MCD::OPC_Decode, 215, 5, 103, // Opcode: STDFrr
/* 6435 */    MCD::OPC_FilterValue, 1, 13, 1, // Skip to: 6708
/* 6439 */    MCD::OPC_Decode, 214, 5, 104, // Opcode: STDFri
/* 6443 */    MCD::OPC_FilterValue, 45, 33, 0, // Skip to: 6480
/* 6447 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6450 */    MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 6468
/* 6454 */    MCD::OPC_CheckPredicate, 0, 250, 0, // Skip to: 6708
/* 6458 */    MCD::OPC_CheckField, 5, 8, 0, 244, 0, // Skip to: 6708
/* 6464 */    MCD::OPC_Decode, 145, 5, 105, // Opcode: PREFETCHr
/* 6468 */    MCD::OPC_FilterValue, 1, 236, 0, // Skip to: 6708
/* 6472 */    MCD::OPC_CheckPredicate, 0, 232, 0, // Skip to: 6708
/* 6476 */    MCD::OPC_Decode, 144, 5, 106, // Opcode: PREFETCHi
/* 6480 */    MCD::OPC_FilterValue, 49, 37, 0, // Skip to: 6521
/* 6484 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6487 */    MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 6507
/* 6491 */    MCD::OPC_CheckField, 25, 5, 0, 211, 0, // Skip to: 6708
/* 6497 */    MCD::OPC_CheckField, 5, 8, 0, 205, 0, // Skip to: 6708
/* 6503 */    MCD::OPC_Decode, 182, 4, 74, // Opcode: LDCSRrr
/* 6507 */    MCD::OPC_FilterValue, 1, 197, 0, // Skip to: 6708
/* 6511 */    MCD::OPC_CheckField, 25, 5, 0, 191, 0, // Skip to: 6708
/* 6517 */    MCD::OPC_Decode, 181, 4, 75, // Opcode: LDCSRri
/* 6521 */    MCD::OPC_FilterValue, 53, 37, 0, // Skip to: 6562
/* 6525 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6528 */    MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 6548
/* 6532 */    MCD::OPC_CheckField, 25, 5, 0, 170, 0, // Skip to: 6708
/* 6538 */    MCD::OPC_CheckField, 5, 8, 0, 164, 0, // Skip to: 6708
/* 6544 */    MCD::OPC_Decode, 201, 5, 74, // Opcode: STCSRrr
/* 6548 */    MCD::OPC_FilterValue, 1, 156, 0, // Skip to: 6708
/* 6552 */    MCD::OPC_CheckField, 25, 5, 0, 150, 0, // Skip to: 6708
/* 6558 */    MCD::OPC_Decode, 200, 5, 75, // Opcode: STCSRri
/* 6562 */    MCD::OPC_FilterValue, 54, 37, 0, // Skip to: 6603
/* 6566 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6569 */    MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 6589
/* 6573 */    MCD::OPC_CheckField, 25, 5, 0, 129, 0, // Skip to: 6708
/* 6579 */    MCD::OPC_CheckField, 5, 8, 0, 123, 0, // Skip to: 6708
/* 6585 */    MCD::OPC_Decode, 207, 5, 74, // Opcode: STDCQrr
/* 6589 */    MCD::OPC_FilterValue, 1, 115, 0, // Skip to: 6708
/* 6593 */    MCD::OPC_CheckField, 25, 5, 0, 109, 0, // Skip to: 6708
/* 6599 */    MCD::OPC_Decode, 206, 5, 75, // Opcode: STDCQri
/* 6603 */    MCD::OPC_FilterValue, 60, 33, 0, // Skip to: 6640
/* 6607 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6610 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 6622
/* 6614 */    MCD::OPC_CheckPredicate, 6, 90, 0, // Skip to: 6708
/* 6618 */    MCD::OPC_Decode, 254, 2, 107, // Opcode: CASArr
/* 6622 */    MCD::OPC_FilterValue, 1, 82, 0, // Skip to: 6708
/* 6626 */    MCD::OPC_CheckPredicate, 0, 78, 0, // Skip to: 6708
/* 6630 */    MCD::OPC_CheckField, 5, 8, 0, 72, 0, // Skip to: 6708
/* 6636 */    MCD::OPC_Decode, 253, 2, 108, // Opcode: CASAri
/* 6640 */    MCD::OPC_FilterValue, 61, 27, 0, // Skip to: 6671
/* 6644 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6647 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 6659
/* 6651 */    MCD::OPC_CheckPredicate, 0, 53, 0, // Skip to: 6708
/* 6655 */    MCD::OPC_Decode, 143, 5, 109, // Opcode: PREFETCHAr
/* 6659 */    MCD::OPC_FilterValue, 1, 45, 0, // Skip to: 6708
/* 6663 */    MCD::OPC_CheckPredicate, 0, 41, 0, // Skip to: 6708
/* 6667 */    MCD::OPC_Decode, 142, 5, 106, // Opcode: PREFETCHAi
/* 6671 */    MCD::OPC_FilterValue, 62, 33, 0, // Skip to: 6708
/* 6675 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6678 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 6690
/* 6682 */    MCD::OPC_CheckPredicate, 0, 22, 0, // Skip to: 6708
/* 6686 */    MCD::OPC_Decode, 128, 3, 110, // Opcode: CASXArr
/* 6690 */    MCD::OPC_FilterValue, 1, 14, 0, // Skip to: 6708
/* 6694 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 6708
/* 6698 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, // Skip to: 6708
/* 6704 */    MCD::OPC_Decode, 255, 2, 111, // Opcode: CASXAri
/* 6708 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableSparcV832[] = {
/* 0 */       MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 3 */       MCD::OPC_FilterValue, 48, 37, 0, // Skip to: 44
/* 7 */       MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 10 */      MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 30
/* 14 */      MCD::OPC_CheckField, 30, 2, 3, 188, 0, // Skip to: 208
/* 20 */      MCD::OPC_CheckField, 5, 8, 0, 182, 0, // Skip to: 208
/* 26 */      MCD::OPC_Decode, 184, 4, 112, // Opcode: LDCrr
/* 30 */      MCD::OPC_FilterValue, 1, 174, 0, // Skip to: 208
/* 34 */      MCD::OPC_CheckField, 30, 2, 3, 168, 0, // Skip to: 208
/* 40 */      MCD::OPC_Decode, 183, 4, 113, // Opcode: LDCri
/* 44 */      MCD::OPC_FilterValue, 51, 37, 0, // Skip to: 85
/* 48 */      MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 51 */      MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 71
/* 55 */      MCD::OPC_CheckField, 30, 2, 3, 147, 0, // Skip to: 208
/* 61 */      MCD::OPC_CheckField, 5, 8, 0, 141, 0, // Skip to: 208
/* 67 */      MCD::OPC_Decode, 188, 4, 114, // Opcode: LDDCrr
/* 71 */      MCD::OPC_FilterValue, 1, 133, 0, // Skip to: 208
/* 75 */      MCD::OPC_CheckField, 30, 2, 3, 127, 0, // Skip to: 208
/* 81 */      MCD::OPC_Decode, 187, 4, 115, // Opcode: LDDCri
/* 85 */      MCD::OPC_FilterValue, 52, 37, 0, // Skip to: 126
/* 89 */      MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 92 */      MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 112
/* 96 */      MCD::OPC_CheckField, 30, 2, 3, 106, 0, // Skip to: 208
/* 102 */     MCD::OPC_CheckField, 5, 8, 0, 100, 0, // Skip to: 208
/* 108 */     MCD::OPC_Decode, 203, 5, 116, // Opcode: STCrr
/* 112 */     MCD::OPC_FilterValue, 1, 92, 0, // Skip to: 208
/* 116 */     MCD::OPC_CheckField, 30, 2, 3, 86, 0, // Skip to: 208
/* 122 */     MCD::OPC_Decode, 202, 5, 117, // Opcode: STCri
/* 126 */     MCD::OPC_FilterValue, 55, 37, 0, // Skip to: 167
/* 130 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 133 */     MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 153
/* 137 */     MCD::OPC_CheckField, 30, 2, 3, 65, 0, // Skip to: 208
/* 143 */     MCD::OPC_CheckField, 5, 8, 0, 59, 0, // Skip to: 208
/* 149 */     MCD::OPC_Decode, 209, 5, 118, // Opcode: STDCrr
/* 153 */     MCD::OPC_FilterValue, 1, 51, 0, // Skip to: 208
/* 157 */     MCD::OPC_CheckField, 30, 2, 3, 45, 0, // Skip to: 208
/* 163 */     MCD::OPC_Decode, 208, 5, 119, // Opcode: STDCri
/* 167 */     MCD::OPC_FilterValue, 58, 37, 0, // Skip to: 208
/* 171 */     MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 174 */     MCD::OPC_FilterValue, 0, 16, 0, // Skip to: 194
/* 178 */     MCD::OPC_CheckField, 29, 3, 4, 24, 0, // Skip to: 208
/* 184 */     MCD::OPC_CheckField, 5, 3, 0, 18, 0, // Skip to: 208
/* 190 */     MCD::OPC_Decode, 140, 6, 76, // Opcode: TRAPrr
/* 194 */     MCD::OPC_FilterValue, 32, 10, 0, // Skip to: 208
/* 198 */     MCD::OPC_CheckField, 29, 3, 4, 4, 0, // Skip to: 208
/* 204 */     MCD::OPC_Decode, 139, 6, 77, // Opcode: TRAPri
/* 208 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableSparcV932[] = {
/* 0 */       MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 3 */       MCD::OPC_FilterValue, 34, 45, 0, // Skip to: 52
/* 7 */       MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 10 */      MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 34
/* 14 */      MCD::OPC_CheckPredicate, 0, 136, 1, // Skip to: 410
/* 18 */      MCD::OPC_CheckField, 30, 2, 3, 130, 1, // Skip to: 410
/* 24 */      MCD::OPC_CheckField, 5, 8, 0, 124, 1, // Skip to: 410
/* 30 */      MCD::OPC_Decode, 204, 4, 120, // Opcode: LDQFrr
/* 34 */      MCD::OPC_FilterValue, 1, 116, 1, // Skip to: 410
/* 38 */      MCD::OPC_CheckPredicate, 0, 112, 1, // Skip to: 410
/* 42 */      MCD::OPC_CheckField, 30, 2, 3, 106, 1, // Skip to: 410
/* 48 */      MCD::OPC_Decode, 203, 4, 121, // Opcode: LDQFri
/* 52 */      MCD::OPC_FilterValue, 38, 45, 0, // Skip to: 101
/* 56 */      MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 59 */      MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 83
/* 63 */      MCD::OPC_CheckPredicate, 0, 87, 1, // Skip to: 410
/* 67 */      MCD::OPC_CheckField, 30, 2, 3, 81, 1, // Skip to: 410
/* 73 */      MCD::OPC_CheckField, 5, 8, 0, 75, 1, // Skip to: 410
/* 79 */      MCD::OPC_Decode, 231, 5, 122, // Opcode: STQFrr
/* 83 */      MCD::OPC_FilterValue, 1, 67, 1, // Skip to: 410
/* 87 */      MCD::OPC_CheckPredicate, 0, 63, 1, // Skip to: 410
/* 91 */      MCD::OPC_CheckField, 30, 2, 3, 57, 1, // Skip to: 410
/* 97 */      MCD::OPC_Decode, 230, 5, 123, // Opcode: STQFri
/* 101 */     MCD::OPC_FilterValue, 48, 39, 0, // Skip to: 144
/* 105 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 108 */     MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 126
/* 112 */     MCD::OPC_CheckPredicate, 0, 38, 1, // Skip to: 410
/* 116 */     MCD::OPC_CheckField, 30, 2, 3, 32, 1, // Skip to: 410
/* 122 */     MCD::OPC_Decode, 196, 4, 124, // Opcode: LDFArr
/* 126 */     MCD::OPC_FilterValue, 1, 24, 1, // Skip to: 410
/* 130 */     MCD::OPC_CheckPredicate, 0, 20, 1, // Skip to: 410
/* 134 */     MCD::OPC_CheckField, 30, 2, 3, 14, 1, // Skip to: 410
/* 140 */     MCD::OPC_Decode, 195, 4, 98, // Opcode: LDFAri
/* 144 */     MCD::OPC_FilterValue, 50, 39, 0, // Skip to: 187
/* 148 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 151 */     MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 169
/* 155 */     MCD::OPC_CheckPredicate, 0, 251, 0, // Skip to: 410
/* 159 */     MCD::OPC_CheckField, 30, 2, 3, 245, 0, // Skip to: 410
/* 165 */     MCD::OPC_Decode, 202, 4, 125, // Opcode: LDQFArr
/* 169 */     MCD::OPC_FilterValue, 1, 237, 0, // Skip to: 410
/* 173 */     MCD::OPC_CheckPredicate, 0, 233, 0, // Skip to: 410
/* 177 */     MCD::OPC_CheckField, 30, 2, 3, 227, 0, // Skip to: 410
/* 183 */     MCD::OPC_Decode, 201, 4, 121, // Opcode: LDQFAri
/* 187 */     MCD::OPC_FilterValue, 51, 39, 0, // Skip to: 230
/* 191 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 194 */     MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 212
/* 198 */     MCD::OPC_CheckPredicate, 0, 208, 0, // Skip to: 410
/* 202 */     MCD::OPC_CheckField, 30, 2, 3, 202, 0, // Skip to: 410
/* 208 */     MCD::OPC_Decode, 190, 4, 126, // Opcode: LDDFArr
/* 212 */     MCD::OPC_FilterValue, 1, 194, 0, // Skip to: 410
/* 216 */     MCD::OPC_CheckPredicate, 0, 190, 0, // Skip to: 410
/* 220 */     MCD::OPC_CheckField, 30, 2, 3, 184, 0, // Skip to: 410
/* 226 */     MCD::OPC_Decode, 189, 4, 100, // Opcode: LDDFAri
/* 230 */     MCD::OPC_FilterValue, 52, 39, 0, // Skip to: 273
/* 234 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 237 */     MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 255
/* 241 */     MCD::OPC_CheckPredicate, 0, 165, 0, // Skip to: 410
/* 245 */     MCD::OPC_CheckField, 30, 2, 3, 159, 0, // Skip to: 410
/* 251 */     MCD::OPC_Decode, 219, 5, 127, // Opcode: STFArr
/* 255 */     MCD::OPC_FilterValue, 1, 151, 0, // Skip to: 410
/* 259 */     MCD::OPC_CheckPredicate, 0, 147, 0, // Skip to: 410
/* 263 */     MCD::OPC_CheckField, 30, 2, 3, 141, 0, // Skip to: 410
/* 269 */     MCD::OPC_Decode, 218, 5, 102, // Opcode: STFAri
/* 273 */     MCD::OPC_FilterValue, 54, 40, 0, // Skip to: 317
/* 277 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 280 */     MCD::OPC_FilterValue, 0, 15, 0, // Skip to: 299
/* 284 */     MCD::OPC_CheckPredicate, 0, 122, 0, // Skip to: 410
/* 288 */     MCD::OPC_CheckField, 30, 2, 3, 116, 0, // Skip to: 410
/* 294 */     MCD::OPC_Decode, 229, 5, 128, 1, // Opcode: STQFArr
/* 299 */     MCD::OPC_FilterValue, 1, 107, 0, // Skip to: 410
/* 303 */     MCD::OPC_CheckPredicate, 0, 103, 0, // Skip to: 410
/* 307 */     MCD::OPC_CheckField, 30, 2, 3, 97, 0, // Skip to: 410
/* 313 */     MCD::OPC_Decode, 228, 5, 123, // Opcode: STQFAri
/* 317 */     MCD::OPC_FilterValue, 55, 40, 0, // Skip to: 361
/* 321 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 324 */     MCD::OPC_FilterValue, 0, 15, 0, // Skip to: 343
/* 328 */     MCD::OPC_CheckPredicate, 0, 78, 0, // Skip to: 410
/* 332 */     MCD::OPC_CheckField, 30, 2, 3, 72, 0, // Skip to: 410
/* 338 */     MCD::OPC_Decode, 211, 5, 129, 1, // Opcode: STDFArr
/* 343 */     MCD::OPC_FilterValue, 1, 63, 0, // Skip to: 410
/* 347 */     MCD::OPC_CheckPredicate, 0, 59, 0, // Skip to: 410
/* 351 */     MCD::OPC_CheckField, 30, 2, 3, 53, 0, // Skip to: 410
/* 357 */     MCD::OPC_Decode, 210, 5, 104, // Opcode: STDFAri
/* 361 */     MCD::OPC_FilterValue, 58, 45, 0, // Skip to: 410
/* 365 */     MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 368 */     MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 392
/* 372 */     MCD::OPC_CheckPredicate, 0, 34, 0, // Skip to: 410
/* 376 */     MCD::OPC_CheckField, 29, 3, 4, 28, 0, // Skip to: 410
/* 382 */     MCD::OPC_CheckField, 5, 3, 0, 22, 0, // Skip to: 410
/* 388 */     MCD::OPC_Decode, 134, 6, 76, // Opcode: TICCrr
/* 392 */     MCD::OPC_FilterValue, 32, 14, 0, // Skip to: 410
/* 396 */     MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 410
/* 400 */     MCD::OPC_CheckField, 29, 3, 4, 4, 0, // Skip to: 410
/* 406 */     MCD::OPC_Decode, 133, 6, 77, // Opcode: TICCri
/* 410 */     MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[Sparc::FeatureV9]);
  case 1:
    return (Bits[Sparc::FeaturePWRPSR]);
  case 2:
    return (Bits[Sparc::FeatureUA2005]);
  case 3:
    return (Bits[Sparc::FeatureVIS3]);
  case 4:
    return (Bits[Sparc::FeatureVIS]);
  case 5:
    return (Bits[Sparc::FeatureVIS2]);
  case 6:
    return (Bits[Sparc::LeonCASA] || Bits[Sparc::FeatureV9]);
  }
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 0, 19);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 3:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 14), 0, 14);
    insertBits(tmp, fieldFromInstruction(insn, 20, 2), 14, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 4:
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 0, 19);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 20, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 0, 30);
    if (!Check(S, DecodeCall(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 11);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 11);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 59:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 62:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 63:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 64:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 65:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 66:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 67:
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 68:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 69:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 70:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 71:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 72:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 73:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 74:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 75:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 76:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 77:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 78:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 79:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 80:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 81:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 82:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 83:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 84:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 85:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 86:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 87:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 88:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 89:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 90:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 91:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 92:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 93:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 94:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 95:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 96:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 97:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 98:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 99:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 100:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 101:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 102:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 103:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 104:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 105:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 106:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 107:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 108:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 109:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 110:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 111:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 112:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 113:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 114:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 115:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 116:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 117:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 118:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 119:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 120:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 121:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 122:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 123:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 124:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 125:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 126:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 127:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 128:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 129:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  }
}

static unsigned decodeNumToSkip(const uint8_t *&Ptr) {
  unsigned NumToSkip = *Ptr++;
  NumToSkip |= (*Ptr++) << 8;
  return NumToSkip;
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr++) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr++;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      uint64_t Val = decodeULEB128AndIncUnsafe(Ptr);
      bool Failed = Val != CurFieldValue;
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // Perform the filter operation.
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << (Failed ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr;
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      bool Failed = ExpectedValue != FieldValue;
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // If the actual and expected values don't match, skip.
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << (Failed ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = decodeNumToSkip(Ptr);
      // Check the predicate.
      bool Failed = !checkDecoderPredicate(PIdx, Bits);
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Failed ? "FAIL\n" : "PASS\n"));

      break;
    }
    case MCD::OPC_Decode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      uint64_t PositiveMask = decodeULEB128AndIncUnsafe(Ptr);
      uint64_t NegativeMask = decodeULEB128AndIncUnsafe(Ptr);
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // namespace
